package controles;

import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.io.FileInputStream;
import java.util.Properties;

/**
 * Clavier
 * @autor Jerome baudoux http://www.jerome-baudoux.com
 */
public class Clavier extends KeyAdapter {
	

	private static Clavier clavier = new Clavier();

	// NUMERO DES TOUCHES
	private int numGauche;
	private int numDroite;
	private int numHaut;
	private int numBas;
	private int numTir;
	private int numTir2;
	private int numEntrer;
	private int numPause;
	private int numEsc;	
	
	// ETATS DES TOUCHES
	private int gauche;
	private int droite;
	private int haut;
	private int bas;
	private int tir;
	private int tir2;
	private int entrer;
	private int pause;
	private int esc;
	
	private int derniereToucheAppuye;

	/**
	 * Constructeur d'un clavier
	 */
	private Clavier()
	{
		numEntrer = 10;
		numEsc = 27;	
		loadKeys();
	}
	
	/**
	 * Lire options
	 */
	public void loadKeys()
	{
		Properties lecteur = new Properties();
		FileInputStream fichier;
		
		try
		{
			fichier = new FileInputStream("Data/clavier.dat");
			lecteur.load(fichier);
			fichier.close();
			
			numGauche	= Integer.parseInt( lecteur.getProperty("left") );	
			numDroite	= Integer.parseInt( lecteur.getProperty("right") );	
			numHaut		= Integer.parseInt( lecteur.getProperty("up") );	
			numBas		= Integer.parseInt( lecteur.getProperty("down") );	
			numTir		= Integer.parseInt( lecteur.getProperty("shoot") );	
			numTir2		= Integer.parseInt( lecteur.getProperty("bomb") );	
			numPause	= Integer.parseInt( lecteur.getProperty("pause") );	
		}
		catch( Exception e)
		{
			numGauche	= 37;	
			numDroite	= 39;	
			numHaut		= 38;	
			numBas		= 40;	
			numTir		= 32;	
			numTir2		= 17;	
		}
	}	
			
	
	/**
	 *  presse
	 * @param keyEvent l'vnement clavier
	 * @see java.awt.event.KeyAdapter#keyPressed(java.awt.event.KeyEvent)
	 */
	public void keyPressed(KeyEvent keyEvent) 
	{
		if (keyEvent.getKeyCode() == numGauche ) 
		{
			if( droite == 1 )
				droite = 2;
			
			gauche = 1;				
		} 
		if (keyEvent.getKeyCode() == numDroite ) 
		{
			if( gauche == 1 )
				gauche = 2;
			
			droite = 1;	
		} 
		if (keyEvent.getKeyCode() == numHaut ) 
		{
			if( bas == 1 )
				bas = 2;
			
			haut = 1;	
		} 
		if (keyEvent.getKeyCode() == numBas ) 
		{
			if( haut == 1 )
				haut = 2;
			
			bas = 1;	
		} 
		if (keyEvent.getKeyCode() == numTir ) 
		{
			tir = 1;
		} 
		if (keyEvent.getKeyCode() == numTir2 ) 
		{
			tir2 = 1;
		} 		
		if (keyEvent.getKeyCode() == numEntrer ) 
		{
			entrer = 1;
		}
		if (keyEvent.getKeyCode() == numPause ) 
		{
			pause = 1;
		}
		if (keyEvent.getKeyCode() == numEsc ) 
		{
			esc = 1;
		}		
		
		derniereToucheAppuye = keyEvent.getKeyCode();
	}

	/**
	 *  relache
	 * @param keyEvent l'vnement clavier
	 * @see java.awt.event.KeyAdapter#keyReleased(java.awt.event.KeyEvent)
	 */
	public void keyReleased(KeyEvent keyEvent) 
	{
		if (keyEvent.getKeyCode() == numGauche ) 
		{
			if( droite == 2 )
				droite = 1;
				
			gauche = 0;
		} 
		if (keyEvent.getKeyCode() == numDroite ) 
		{
			if( gauche == 2 )
				gauche = 1;
				
			droite = 0;
		}
		if (keyEvent.getKeyCode() == numHaut ) 
		{
			if( bas == 2 )
				bas = 1;
			
			haut = 0;
		}
		if (keyEvent.getKeyCode() == numBas ) 
		{
			if( haut == 2 )
				haut = 1;
			
			bas = 0;
		}
		if (keyEvent.getKeyCode() == numTir ) 
		{
			tir = 0;
		}
		if (keyEvent.getKeyCode() == numTir2 ) 
		{
			tir2 = 0;
		}		
		if (keyEvent.getKeyCode() == numEntrer ) 
		{
			entrer = 0;
		}
		if (keyEvent.getKeyCode() == numPause ) 
		{
			pause = 0;
		}
		if (keyEvent.getKeyCode() == numEsc ) 
		{
			pause = 0;
		}			
	}
	
	public int getDerniereToucheAppuye()
	{
		return derniereToucheAppuye;
	}

	public int[] getListeTouches()
	{
		int[] ret = new int[7];
		
		ret[0] = numHaut;
		ret[1] = numBas;
		ret[2] = numGauche;
		ret[3] = numDroite;
		ret[4] = numTir;
		ret[5] = numTir2;
		ret[6] = numPause;
		
		return ret;
	}
	
	public static Clavier getClavier()
	{
		return clavier;
	}

	public boolean isBas()
	{
		return bas==1;
	}

	public boolean isDroite()
	{
		return droite==1;
	}

	public boolean isEntrer()
	{
		return entrer==1 || tir==1;
	}
	
	public boolean isESC()
	{
		return esc==1;
	}	

	public boolean isTir()
	{
		return tir==1;
	}
	
	public boolean isTir2()
	{
		return tir2==1;
	}	

	public boolean isGauche()
	{
		return gauche==1;
	}

	public boolean isHaut()
	{
		return haut==1;
	}

	public boolean isPause()
	{
		return pause==1;
	}
	
	public void entrerOk()
	{
		entrer 				 = 0;
		tir    				 = 0;
		derniereToucheAppuye = 27;
	}
	
	public void ESCOk()
	{
		esc  				 = 0;
		derniereToucheAppuye = 10;
	}	
	
	public void pauseOk()
	{
		pause = 0;
	}	
	
	public void tir2Ok()
	{
		tir2 = 0;
	}
	
	public void allOk()
	{
		gauche 	= 0;
		droite 	= 0;
		haut 	= 0;
		bas 	= 0;
		tir 	= 0;
		tir2 	= 0;
		entrer 	= 0;
		pause 	= 0;
		esc 	= 0;
	}		

}
