package controles;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.Vector;
import elements.Ennemis.*;
import elements.Ennemis.Boss.*;

/**
 * 
 * @autor Jerome baudoux http://www.jerome-baudoux.com
 *
 */
public class EnnemisManager 
{
	private int niveau;
	private boolean stopTime;
	private long temps;	
	private Vector<Integer[]> ennemisStock;

	public EnnemisManager( int n )
	{
		niveau			= n;
		temps 			= 0;
		ennemisStock 	= new Vector<Integer[]>(0);
		lire();
	}
	
	public void lire()
	{
		BufferedReader fichier ;
		
		try
		{
			fichier = new BufferedReader( new FileReader("Niveaux/niveau"+niveau+".dat") );
			String a;
			
			while( true )
			{
				a = fichier.readLine();
				
				if( a.length() > 2 && a.charAt(0) != '#')
				{
					Integer[] tmp = new Integer[9];	
					String[] tmp2 = a.split("\t");			
	
					for( int i=0; i< tmp.length ; i++)
					{
						tmp[i] = Integer.parseInt( tmp2[i] );
					}
					
					ennemisStock.add( tmp );
				}
			}
		}
		catch( Exception e){}
	}
	
	public void refresh( long t )
	{
		if( ! stopTime )
			temps +=t;
		else
			if( Environnement.getEnvironnement().ennemis.size() == 0 )
			{
				stopTime = false;
				temps = 0;
			}
		
		boolean ok = false;
		int bonus;
		
		for( int i=0; i < ennemisStock.size() && !ok && !stopTime; i++)
		{
			
			if( ennemisStock.get(i)[0] < temps)
			{
				if( ennemisStock.get(i)[1] == -1 )
					stopTime = true;
				
				// FIN DU NIVEAU
				if( ennemisStock.get(i)[1] == -2 )
				{
					Environnement.getEnvironnement().gameState = Environnement.LEVEL_CLEAR;
					SonManager.getSonManager().setMusiqueEnCours( SonManager.getSonManager().musiqueYouWin );
					SonManager.getSonManager().jouerMusique();
				}
				
				
				// VITESSE DU SCROLLING
				if( ennemisStock.get(i)[1] == -3 )
				{
					NiveauManager.getNiveauManager().getNiveau().setScrolling( ennemisStock.get(i)[2] );
				}
				
				try
				{
					// BONUS
					if( ennemisStock.get(i)[6] == 0 && ennemisStock.get(i)[7] == 0 )
						bonus = Ennemi.RIEN;
					else if( ennemisStock.get(i)[6] == 1 && ennemisStock.get(i)[7] == 0 )
						bonus = Ennemi.ITEM_TIR;
					else  if( ennemisStock.get(i)[6] == 0 && ennemisStock.get(i)[7] == 1 )
						bonus = Ennemi.ITEM_BOMBE;
					else
						bonus = Ennemi.ITEM_TIR_ET_BOMBE;
					
					// QUI EST QUI ?
					if( ennemisStock.get(i)[1] == 0 )
						Environnement.getEnvironnement().ennemis.add( new EnnemiBasique( ennemisStock.get(i)[2] + 212, ennemisStock.get(i)[3], ennemisStock.get(i)[4], ennemisStock.get(i)[5], bonus )  );
					
					else if( ennemisStock.get(i)[1] == 1 )
						Environnement.getEnvironnement().ennemis.add( new EnnemiEvol1( ennemisStock.get(i)[2] + 212, ennemisStock.get(i)[3], ennemisStock.get(i)[4], ennemisStock.get(i)[5], bonus)  );
										
					else if( ennemisStock.get(i)[1] == 2 )
						Environnement.getEnvironnement().ennemis.add( new EnnemiEvol2( ennemisStock.get(i)[2] + 212, ennemisStock.get(i)[3], ennemisStock.get(i)[4], ennemisStock.get(i)[5], bonus, ennemisStock.get(i)[8])  );

					else if( ennemisStock.get(i)[1] == 3 )
						Environnement.getEnvironnement().ennemis.add( new EnnemiEvol3( ennemisStock.get(i)[2] + 212, ennemisStock.get(i)[3], ennemisStock.get(i)[4], ennemisStock.get(i)[5], bonus, ennemisStock.get(i)[8])  );
				
					else if( ennemisStock.get(i)[1] == 4 )
						Environnement.getEnvironnement().ennemis.add( new EnnemiMine( ennemisStock.get(i)[2] + 212, ennemisStock.get(i)[3], ennemisStock.get(i)[4], ennemisStock.get(i)[5], bonus, ennemisStock.get(i)[8])  );

					else if( ennemisStock.get(i)[1] == 5 )
						Environnement.getEnvironnement().ennemis.add( new EnnemiEvol5( ennemisStock.get(i)[2] + 212, ennemisStock.get(i)[3], ennemisStock.get(i)[4], ennemisStock.get(i)[5], bonus)  );

					else if( ennemisStock.get(i)[1] == 6 )
						Environnement.getEnvironnement().ennemis.add( new TankSmall( ennemisStock.get(i)[2] + 212, ennemisStock.get(i)[3], ennemisStock.get(i)[4], ennemisStock.get(i)[5], bonus, ennemisStock.get(i)[8])  );

					else if( ennemisStock.get(i)[1] == 7 )
						Environnement.getEnvironnement().ennemis.add( new TankMed( ennemisStock.get(i)[2] + 212, ennemisStock.get(i)[3], ennemisStock.get(i)[4], ennemisStock.get(i)[5], bonus, ennemisStock.get(i)[8])  );

					else if( ennemisStock.get(i)[1] == 8 )
						Environnement.getEnvironnement().ennemis.add( new Train( ennemisStock.get(i)[2],ennemisStock.get(i)[3],  ennemisStock.get(i)[4], bonus)  );

					
					//BOSS
					
					else if( ennemisStock.get(i)[1] == 100 )
						Environnement.getEnvironnement().ennemis.add( new Boss1()  );
					else if( ennemisStock.get(i)[1] == 101 )
						Environnement.getEnvironnement().ennemis.add( new Boss2()  );
					else if( ennemisStock.get(i)[1] == 102 )
						Environnement.getEnvironnement().ennemis.add( new Boss3()  );
									
				}
				catch( Exception e){}
				
				ennemisStock.remove( i );
				i--;
			}
			else
				ok = true;
			
		}
	}
}
