package controles;

import java.awt.Toolkit;
import javax.swing.ImageIcon;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class ImageManager 
{
	// STATUTS
	public ImageIcon[] statut;
	public ImageIcon   fond;
	
	//Explosions
	public ImageIcon[] explosionEnnemi;
	public ImageIcon[] explosionTir;
	public ImageIcon[] explosionJoueur;
	public ImageIcon[] explosionLaser;
	
	//Tirs
	public ImageIcon[] tirJoueur;
	public ImageIcon[] tirLaser;
	public ImageIcon[] tirEnnemi;
	public ImageIcon   bombe;
	
	//Items
	public ImageIcon[] ItemPoint;	
	public ImageIcon[] ItemTir;	
	public ImageIcon[] ItemTirMP;	
	public ImageIcon[] ItemBombe;	
	
	//Ennemis
	public ImageIcon[] ennemi;
	public ImageIcon[] boss;
	
	private static ImageManager img = new ImageManager();
	
	public ImageManager()
	{
		fond				= new ImageIcon( java.awt.Toolkit.getDefaultToolkit().getImage("Images/Board/fond.png"));
		
		// STATUTS
		statut 				=  new ImageIcon[7];	
		
		statut[0]			= new ImageIcon( java.awt.Toolkit.getDefaultToolkit().getImage("Images/Menus/ready.png"));
		statut[1]			= new ImageIcon( java.awt.Toolkit.getDefaultToolkit().getImage("Images/Menus/go.png"));
		statut[2]			= new ImageIcon( java.awt.Toolkit.getDefaultToolkit().getImage("Images/Menus/level.png"));
		statut[3]			= new ImageIcon( java.awt.Toolkit.getDefaultToolkit().getImage("Images/Menus/clear.png"));
		statut[4]			= new ImageIcon( java.awt.Toolkit.getDefaultToolkit().getImage("Images/Menus/youLoose.png"));
		statut[5]			= new ImageIcon( java.awt.Toolkit.getDefaultToolkit().getImage("Images/Menus/warning.png"));
		

		// EXPLOSIONS
		explosionEnnemi 	=  new ImageIcon[5];
		explosionTir 		=  new ImageIcon[3];
		explosionJoueur 	=  new ImageIcon[5];
		explosionLaser 		=  new ImageIcon[5];
		
		for( int i=0; i< explosionEnnemi.length; i++)
			explosionEnnemi[i] 	= new ImageIcon( Toolkit.getDefaultToolkit().getImage("Images/Explosion/exp1_"+i+".png"));
		
		for( int i=0; i< explosionTir.length; i++)
			explosionTir[i] 	= new ImageIcon( Toolkit.getDefaultToolkit().getImage("Images/Explosion/exp2_"+i+".png"));
		
		for( int i=0; i< explosionJoueur.length; i++)
			explosionJoueur[i] 	= new ImageIcon( Toolkit.getDefaultToolkit().getImage("Images/Explosion/exp3_"+i+".png"));

		for( int i=0; i< explosionLaser.length; i++)
			explosionLaser[i] 	= new ImageIcon( Toolkit.getDefaultToolkit().getImage("Images/Explosion/exp4_"+i+".png"));

		
		// Tirs
		tirJoueur = new ImageIcon[4];
		tirEnnemi = new ImageIcon[2];
		tirLaser  = new ImageIcon[6];
		
		for( int i=0; i< tirJoueur.length; i++)
			tirJoueur[i] = new ImageIcon( Toolkit.getDefaultToolkit().getImage("Images/Tirs/JoueurTir"+i+".png"));
				
		for( int i=0; i< tirEnnemi.length; i++)
			tirEnnemi[i] = new ImageIcon( Toolkit.getDefaultToolkit().getImage("Images/Tirs/EnnemiTir"+i+".png"));

		for( int i=0; i< tirLaser.length; i++)
			tirLaser[i] = new ImageIcon( Toolkit.getDefaultToolkit().getImage("Images/Tirs/Laser"+i+".png"));
		
		bombe = new ImageIcon( Toolkit.getDefaultToolkit().getImage("Images/Tirs/bombe.png"));
				
		
		
		// Items	
		ItemPoint 	= new ImageIcon[6];
		ItemTir 	= new ImageIcon[6];
		ItemTirMP 	= new ImageIcon[6];
		ItemBombe 	= new ImageIcon[6];
		
		for( int i=0; i< ItemPoint.length; i++)
			ItemPoint[i] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Items/pt"+i+".png"));
		
		for( int i=0; i< ItemTir.length; i++)
			ItemTir[i] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Items/itemTir"+i+".png"));
		
		for( int i=0; i< ItemTirMP.length; i++)
			ItemTirMP[i] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Items/itemTirMP"+i+".png"));
		
		for( int i=0; i< ItemBombe.length; i++)
			ItemBombe[i] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Items/itemBombe"+i+".png"));
			
		
		// Ennemis
		ennemi = new ImageIcon[17];
		
		ennemi[0] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ennemis/e1.png"));
		ennemi[1] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ennemis/e2.png"));
		ennemi[2] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ennemis/e3_top.png"));
		ennemi[3] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ennemis/e3_bottom.png"));
		ennemi[4] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ennemis/e4_top.png"));
		ennemi[5] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ennemis/e4_bottom.png"));
		ennemi[6] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ennemis/e5.png"));		
		ennemi[7] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ennemis/e6.png"));		
		ennemi[8] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ennemis/tankSmall_bottom.png"));		
		ennemi[9] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ennemis/tankSmall_top.png"));		
		ennemi[10] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ennemis/tankMed_bottom.png"));		
		ennemi[11] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ennemis/tankMed_top.png"));		
		ennemi[12] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ennemis/rails.png"));		
		ennemi[13] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ennemis/train_loco.png"));		
		ennemi[14] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ennemis/train_wagon_arme.png"));		
		ennemi[15] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ennemis/train_wagon.png"));				
		ennemi[16] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ennemis/train_wagon_circ.png"));				
	}
	
	public static ImageManager getImagemanager()
	{
		return img;
	}
	
	public ImageIcon getImageFond()
	{
		return fond;
	}
	
	public ImageIcon getStaut( int i )
	{
		return statut[i];
	}
	
	
	public ImageIcon getExplosionEnnemi( int i )
	{
		return explosionEnnemi[i];
	}
	
	public ImageIcon getExplosionTir( int i )
	{
		return explosionTir[i];
	}
	
	public ImageIcon getExplosionJoueur( int i )
	{
		return explosionJoueur[i];
	}	

	public ImageIcon getExplosionLaser( int i )
	{
		return explosionLaser[i];
	}		
	
	
	public ImageIcon getJoueurTir( int i )
	{
		return tirJoueur[i];
	}
	
	public ImageIcon getJoueurLaser( int i )
	{
		return tirLaser[i];
	}	
	
	public ImageIcon getEnnemiTir( int i )
	{
		return tirEnnemi[i];
	}	
	
	public ImageIcon getBombe()
	{
		return bombe;
	}
	
	
	
	public ImageIcon getItemPoint( int i )
	{
		return ItemPoint[i];
	}	
	
	public ImageIcon getItemTir( int i )
	{
		return ItemTir[i];
	}	
	
	public ImageIcon getItemTirMP( int i )
	{
		return ItemTirMP[i];
	}
	
	public ImageIcon getItemBombe( int i )
	{
		return ItemBombe[i];
	}	
	
	
	
	
	public ImageIcon getEnnemi( int i )
	{
		return ennemi[i];
	}
	
	public ImageIcon getBoss( int i )
	{
		return boss[i];
	}	
}
