package controles;
import java.io.File;
import sons.Son;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class SonManager 
{
	private static SonManager son = new SonManager();
	
	public Boolean ok;
	
	// MUSIQUES
	public  Son   musiqueJeu;
	public  Son   musiqueBoss;
	public  Son	  musiqueYouLoose;
	public  Son   musiqueYouWin;
	public  Son   musiqueEndOfBlackArmada;
	public  Son   MusiqueMenu;	
	public  Son   musiqueIntro;
	private Son   musiqueEnCours;

	// TEMPS
	public  Son[]   temp;
	
	// EFFETCTS
	private Son   beep2;
	private Son   bombe;	
	private Son	  warning;
	private Son   laser;
	private Son   laserBombe;
	private Son[] beep;	
	private Son[] tir;
	private Son[] explosionBig;
	private Son[] explosionBoss;
	private Son[] explosion;
	private Son[] expBoss;
	private Son[] points;
	private Son[] itemTir;
	
	// STATUT ( INTRO ET LEVEL CLEAR )
	private Son ready;
	private Son go;
	private Son levelClear;
	private Son youLoose;
	
	private SonManager()
	{

		tir 			= new Son[4];
		explosionBig 	= new Son[4];
		explosionBoss 	= new Son[2];
		explosion 		= new Son[4];
		expBoss			= new Son[8];
		points 			= new Son[4];
		itemTir			= new Son[4];
		beep			= new Son[4];
		temp			= new Son[2];

		String path = this.getClass().getResource(".").getPath().replaceAll("%20", " ");
		path 		+= "../../";

		try{for( int i=0;i<tir.length;i++)
				tir[i] 				= new Son( new File( path + "Sons/laser2.wav"			) );
		}catch( Exception e){}
		
		try{for( int i=0;i<beep.length;i++)
			beep[i] 				= new Son( new File( path + "Sons/beep.wav"				) );
		}catch( Exception e){}
		
		try{for( int i=0;i<explosionBig.length;i++)
			explosionBig[i] 	= new Son( new File( path + "Sons/explosionBig.wav"			) );
		}catch( Exception e){}
		
		try{for( int i=0;i<explosionBoss.length;i++)
				explosionBoss[i] 	= new Son( new File( path + "Sons/explosionBoss.wav"	) );
		}catch( Exception e){}
		
		try{for( int i=0;i<explosion.length;i++)
				explosion[i] 		= new Son( new File( path + "Sons/exp2.wav"				) );
		}catch( Exception e){}
		
		try{for( int i=0;i<expBoss.length;i++)
				expBoss[i] 			= new Son( new File( path + "Sons/expBoss.wav"			) );
		}catch( Exception e){}			
		
		try{for( int i=0;i<points.length;i++)
				points[i]	 		= new Son( new File( path + "Sons/points.wav"			) );
		}catch( Exception e){}

		try{for( int i=0;i<itemTir.length;i++)
				itemTir[i] 			= new Son( new File( path + "Sons/itemTir.wav"			) );
		}catch( Exception e){}	
		
		try{warning					= new Son( new File( path + "Sons/warning.wav"				) );}catch( Exception e){}
		try{youLoose 				= new Son( new File( path + "Sons/youLoose.wav"				) );}catch( Exception e){}	
		try{bombe 					= new Son( new File( path + "Sons/bombe.wav"				) );}catch( Exception e){}
		try{laser       			= new Son( new File( path + "Sons/laser.wav"				) );}catch( Exception e){}
		try{laserBombe  			= new Son( new File( path + "Sons/laserbombe.wav"			) );}catch( Exception e){}
		try{ready 					= new Son( new File( path + "Sons/ready.wav"				) );}catch( Exception e){}
		try{go 						= new Son( new File( path + "Sons/go.wav"					) );}catch( Exception e){}			
		try{levelClear 				= new Son( new File( path + "Sons/levelClear.wav"			) );}catch( Exception e){}			
		try{beep2  					= new Son( new File( path + "Sons/beep2.wav"				) );}catch( Exception e){}
		
		try{temp[0]  				= new Son( new File( path + "Sons/alarm.wav"				) );}catch( Exception e){}
		try{temp[1]  				= new Son( new File( path + "Sons/open.wav"					) );}catch( Exception e){}
		
		try{musiqueJeu				= new Son( new File( path + "Musiques/jeu.wav"				) );}catch( Exception e){}
		try{musiqueBoss 			= new Son( new File( path + "Musiques/boss.wav"				) );}catch( Exception e){}
		try{musiqueYouLoose 		= new Son( new File( path + "Musiques/youLoose.wav"			) );}catch( Exception e){}
		try{musiqueYouWin	 		= new Son( new File( path + "Musiques/youWin.wav"			) );}catch( Exception e){}			
		try{musiqueEndOfBlackArmada = new Son( new File( path + "Musiques/endOfBlackArmada.wav"	) );}catch( Exception e){}
		try{MusiqueMenu 			= new Son( new File( path + "Musiques/menu.wav" 			) );}catch( Exception e){}
		try{musiqueIntro 			= new Son( new File( path + "Musiques/intro.wav" 			) );}catch( Exception e){}
		
	}
	
	public boolean isOk()
	{
		return musiqueEndOfBlackArmada.ok && musiqueYouWin.ok && musiqueYouLoose.ok && musiqueBoss.ok && musiqueJeu.ok;
	}
	
	public static SonManager getSonManager()
	{
		return son;
	}
	
	
	/*
	 * MUSIQUE EN COURS
	 */	
	
	public void setMusiqueEnCours( Son musique )
	{
		if( musiqueEnCours != null)
			musiqueEnCours.stop();
		
		musiqueEnCours = musique;
	}

	public void jouerMusique()
	{
		if( musiqueEnCours != null )
		{
			if( musiqueEnCours.estEnPause() )
				musiqueEnCours.reprise();
			else
				if( ! musiqueEnCours.estEntrainDeJouer() )
					musiqueEnCours.boucle();
		}
	}
	
	public void pauseMusique()
	{
		if( musiqueEnCours != null )
			musiqueEnCours.pause();
	}	
	
	public void stopMusique()
	{
		if( musiqueEnCours != null )
			musiqueEnCours.stop();
	}
	
	
	/*
	 * SONS
	 */
	
	public void jouerBeep()
	{
		if( beep[0] != null )
		{
			if( ! beep[0].estEntrainDeJouer())
				beep[0].jouer();
			else if( ! beep[1].estEntrainDeJouer())
				beep[1].jouer();
			else if( ! beep[2].estEntrainDeJouer())
				beep[2].jouer();
			else
				beep[3].jouer();
		}
	}
	
	public void jouerBeep2()
	{
		if( beep2 != null )
			beep2.jouer();
	}
	
	public void jouerWarning()
	{
		if( warning != null )
			if( warning.estEnPause() )
				warning.reprise();
			else
				warning.jouer();
	}
	
	public void pauseWarning()
	{
		if( warning != null )
			if( warning.estEntrainDeJouer() )
				warning.pause();
	}
	
	public void jouerLaser2()
	{
		if( ! tir[0].estEntrainDeJouer())
			tir[0].jouer();
		else if( ! tir[1].estEntrainDeJouer())
			tir[1].jouer();
		else if( ! tir[2].estEntrainDeJouer())
			tir[2].jouer();
		else
			tir[3].jouer();
	}
	
	public void jouerLaser()
	{
		if( laser != null && ! laser.estEntrainDeJouer())
			laser.jouer();
	}
	
	public void stopLaser()
	{
		if( laser != null && laser.estEntrainDeJouer())
			laser.stop();
	}
	
	public void jouerLaserBombe()
	{
		if( laserBombe != null && ! laserBombe.estEntrainDeJouer())
			laserBombe.jouer();
	}
	
	public void stopLaserBombe()
	{
		if( laserBombe != null && laserBombe.estEntrainDeJouer())
			laserBombe.stop();
	}
	
	public void jouerExplosion()
	{
		if( ! explosion[0].estEntrainDeJouer())
			explosion[0].jouer();
		else if( ! explosion[1].estEntrainDeJouer())
			explosion[1].jouer();
		else if( ! explosion[2].estEntrainDeJouer())
			explosion[2].jouer();
		else
			explosion[3].jouer();	
	}
	
	public void jouerExplosionBig()
	{
		// Joue un son
		if( ! explosionBig[0].estEntrainDeJouer())
			explosionBig[0].jouer();
		else if( ! explosionBig[1].estEntrainDeJouer())
			explosionBig[1].jouer();
		else if( ! explosionBig[2].estEntrainDeJouer())
			explosionBig[2].jouer();
		else
			explosionBig[3].jouer();
	}
	
	public void jouerExplosionBoss()
	{
		boolean ok = false;
		for( int i=0; i< explosionBoss.length && !ok; i++)
			if( ! explosionBoss[i].estEntrainDeJouer() )
			{
				explosionBoss[i].jouer();
				ok = true;
			}
	}
	
	public void jouerExpBoss()
	{
		boolean ok = false;
		for( int i=0; i< expBoss.length && !ok; i++)
			if( ! expBoss[i].estEntrainDeJouer() )
			{
				expBoss[i].jouer();
				ok = true;
			}
	}
	
	public void jouerItemtir()
	{
		// Joue un son
		if( ! itemTir[0].estEntrainDeJouer())
			itemTir[0].jouer();
		else if( ! itemTir[1].estEntrainDeJouer())
			itemTir[1].jouer();
		else if( ! itemTir[2].estEntrainDeJouer())
			itemTir[2].jouer();
		else
			itemTir[3].jouer();	
	}
	
	public void jouerPoints()
	{
		// Joue un son
		if( ! points[0].estEntrainDeJouer())
			points[0].jouer();
		else if( ! points[1].estEntrainDeJouer())
			points[1].jouer();
		else if( ! points[2].estEntrainDeJouer())
			points[2].jouer();
		else
			points[3].jouer();	
	}
	
	public void jouerBombe()
	{
		if( bombe != null )
			bombe.jouer();	
	}	
	
	public void jouerReady()
	{
		if( ready != null)
			ready.jouer();	
	}		
	
	public void jouerGo()
	{
		if( go != null )
			go.jouer();	
	}		
	
	public void jouerLevelClear()
	{
		if( levelClear != null )
		levelClear.jouer();	
	}		
	
	public void jouerYouLoose()
	{
		if( youLoose != null )
		youLoose.jouer();	
	}		

}
