package elements.Ennemis.Boss;

import java.awt.AlphaComposite;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.util.Vector;

import controles.Environnement;
import controles.SonManager;
import elements.Ennemis.Ennemi;
import elements.Explosions.ExplosionEnnemi;
import elements.Tirs.TirEnnemi;
import elements.items.ItemTir;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class Boss extends Ennemi
{
	protected double temps;
	protected int ennergieMax;
	
	int itemTirADropper;

	/**
	 * Constructeur
	 */
	public Boss(int xx, int yy, int vx, int vy, int e, int p, int ev, int b, int dc, int ds, int ncs)
	{
		super(xx,yy,vx,vy,e,p,ev,b,dc,ds,ncs);
		ennergieMax = e;
		initBoss();
		Environnement.getEnvironnement().modeBoss = true;
		
		itemTirADropper = 2;
	}	
	
	/**
	 * Change la zik
	 */
	private void initBoss()
	{
		temps = 0;
		SonManager.getSonManager().setMusiqueEnCours( SonManager.getSonManager().musiqueBoss );	
	}
	
	/**
	 * Boss meurt
	 */
	protected void die()
	{
		super.die();
		Environnement.getEnvironnement().tirsEnnemi = new Vector<TirEnnemi>(0);
	}	
	
	/**
	 * Refresh
	 */
	public void refresh(long t) 
	{
		if( temps < 5000 )
		{
			temps+=t;
			SonManager.getSonManager().jouerWarning();
		}
		else
		{
			super.refresh(t);
			SonManager.getSonManager().jouerMusique();
			
			/* Drop un <P> tous les 33% de la barre du boss */
			if( ( (ennergie/(float)ennergieMax) < itemTirADropper*0.33 ) && ennergie > 0)
			{
				SonManager.getSonManager().jouerExplosionBig();
				Environnement.getEnvironnement().exps.add( new ExplosionEnnemi( (int)getArea().getBounds2D().getCenterX(), (int)getArea().getBounds2D().getCenterY()));
				Environnement.getEnvironnement().items.add( new ItemTir( (int)getArea().getBounds2D().getCenterX(), (int)getArea().getBounds2D().getCenterY(), 150 ));
				itemTirADropper--;
			}
			
		}
	}
	
	/**
	 * On laisse faire la classe ennemi
	 */
	public void shape( Graphics graphics )
	{
			super.shape(graphics);	
	}
	
	/**
	 * Barre d'energie du boss
	 */
	public void shapeForeground( Graphics graphics )
	{
		super.shapeForeground(graphics);	
		
		if( temps < 5000 )
		{
			
			float alpha;
			
			// Modifie l'alpha
			if( temps < 2000 || ( temps > 2500 && temps < 4000 ) )
				alpha = (float)((temps)%2500/2000.0f);	
			else
				alpha = (float)( (1 - (temps%2500-2500) )/1000 );
			
			// Evite les bugs d'alpha
			if( alpha > 1 )
				alpha = 1;
			if( alpha < 0 )
				alpha = 0;
			
			
			// AFFICHAGE DU WARNING
			Graphics2D g = (Graphics2D) graphics;
			g.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, alpha ));	
			g.drawImage( imgLoad.getStaut(5).getImage(), 512 - imgLoad.getStaut(5).getIconWidth()/2, 300, null );
			g.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 1f ));	
			
		}

		
		// AFFICHAGE DE LA BARRE D'ENNERGIE
		int ennergieRest = ennergie*534/ennergieMax; 
	
		Graphics2D graphics2d = ((Graphics2D)graphics);
	
		graphics2d.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.1f ));
			graphics2d.setStroke( new BasicStroke( 6f ) );
				graphics2d.setColor( Color.yellow );
				graphics2d.drawRect(245, 693, ennergieRest, 2);
			graphics2d.setStroke( new BasicStroke() );
		graphics2d.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 1f ));	
		
		graphics2d.setColor( Color.black );		
		graphics2d.drawRect(242, 690, 1024-242*2, 8);			
				
	}
	
	/**
	 * Tjrs au dessus des autres streums
	 */
	public int compareTo(Ennemi e) 
	{
		return 1;
	}
	
	public String getType()
	{
		return "Boss";
	}
}
