package elements.Ennemis.Boss;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.geom.AffineTransform;
import java.awt.geom.Area;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Rectangle2D;
import java.awt.image.AffineTransformOp;
import java.awt.image.BufferedImage;
import java.util.Random;
import java.util.Vector;
import javax.swing.ImageIcon;

import controles.Environnement;
import controles.SonManager;
import elements.Ennemis.Ennemi;
import elements.Explosions.Explosion;
import elements.Explosions.ExplosionEnnemi;
import elements.Tirs.*;
import elements.items.ItemBombe;
import elements.items.ItemPoint;
import elements.items.ItemTir;


/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class Boss2 extends Boss
{
	private Boss2Sub 	partie1;
	private Boss2Sub 	partie2;
	private Boss2Sub 	partie3;
	private Boss2Sub 	partie4;
	private Boss2Sub2[] cannons;
	private Boss2Sub3   tourelle;
	
	private float 		rotation;
	private double 		tempsAvantRotation;
	private int 		etat;
	private int 		deplacementVersEtat;
	private int			antiAliasingSave;
	
	
	/**
	 * Constructeur
	 */
	public Boss2()
	{
		super( 286 ,-500,0,100,20000,7000,100,0,300,1000,4);

		// Parties cassables
		partie1 			= new Boss2Sub(1,   0,	  0	);
		partie2 			= new Boss2Sub(2, 226,	  0	);
		partie3 			= new Boss2Sub(3, 226,	226	);
		partie4 			= new Boss2Sub(4,   0,	226	);
		tourelle			= new Boss2Sub3();
		
		// Cannons sous les parties cassables
		cannons 			= new Boss2Sub2[4];
		cannons[0] 			= new Boss2Sub2();
		cannons[1] 			= new Boss2Sub2();
		cannons[2] 			= new Boss2Sub2();
		cannons[3] 			= new Boss2Sub2();
		
		// Variables
		etat 				= 0;
		rotation 			= 0;
		deplacementVersEtat = -1;
		tempsAvantRotation  = 10000;
		img 				= imgLoad.getBoss(0);
		
		antiAliasingSave = Environnement.getEnvironnement().antiAliasing;
		Environnement.getEnvironnement().antiAliasing = 0;
	}
	

	
	
	
	/**
	 * 
	 * 
	 * 
	 * 
	 * 
	 * GERE LA ROUTINE DES TIRS
	 * 
	 * 
	 * 
	 * 
	 * 
	 */
	public void gestionTirs()
	{
		// TIRS DE LA PARTIE 1 VIVANTE
		if( ! partie1.isDead() && ( etat == 2 || etat == 3) && tourelle.pretTirer() )
		{
			tirs.add( new TirEnnemiInvincible(	
					
					(int) (Math.cos( Math.toRadians(tourelle.angle+rotation-90) )*155 +	(int) (Math.cos( Math.toRadians(rotation-135) )*50 + x + 226) ), 
					(int) (Math.sin( Math.toRadians(tourelle.angle+rotation-90) )*155 +	(int) (Math.sin( Math.toRadians(rotation-135) )*50 + y + 226) ), 			
					
					(int) (Math.cos( Math.toRadians(rotation-135+tourelle.angle+45) )*200), 
					(int) (Math.sin( Math.toRadians(rotation-135+tourelle.angle+45) )*200)) );
			
			tirs.add( new TirEnnemi(	
					
					(int) (Math.cos( Math.toRadians(tourelle.angle+rotation-90) )*155 +	(int) (Math.cos( Math.toRadians(rotation-135) )*50 + x + 226) ), 
					(int) (Math.sin( Math.toRadians(tourelle.angle+rotation-90) )*155 +	(int) (Math.sin( Math.toRadians(rotation-135) )*50 + y + 226) ), 			
					
					(int) (Math.cos( Math.toRadians(rotation-135+tourelle.angle+50) )*250), 
					(int) (Math.sin( Math.toRadians(rotation-135+tourelle.angle+50) )*250)) );
			
			tirs.add( new TirEnnemi(	
					
					(int) (Math.cos( Math.toRadians(tourelle.angle+rotation-90) )*155 +	(int) (Math.cos( Math.toRadians(rotation-135) )*50 + x + 226) ), 
					(int) (Math.sin( Math.toRadians(tourelle.angle+rotation-90) )*155 +	(int) (Math.sin( Math.toRadians(rotation-135) )*50 + y + 226) ), 			
					
					(int) (Math.cos( Math.toRadians(rotation-135+tourelle.angle+40) )*250), 
					(int) (Math.sin( Math.toRadians(rotation-135+tourelle.angle+40) )*250)) );
			
			tourelle.tirOk();
			SonManager.getSonManager().jouerExpBoss();
		}	
		
		
		
		if( pretTirer() )
		{
			Boolean aTire = false;
						
			
			// TIRS DE LA PARTIE 3 VIVANTE
			if( ! partie3.isDead() && ( etat == 0 || etat == 1) )
			{
				tirs.add( new TirEnnemi(	(int) (Math.cos( Math.toRadians(rotation+80) )*180 + x + 226), 
											(int) (Math.sin( Math.toRadians(rotation+80) )*180 + y + 226), 
											(int) (Math.cos( Math.toRadians(rotation+90) )*200), 
											(int) (Math.sin( Math.toRadians(rotation+90) )*200)) );
				
				tirs.add( new TirEnnemi(	(int) (Math.cos( Math.toRadians(rotation+50) )*180 + x + 226), 
											(int) (Math.sin( Math.toRadians(rotation+50) )*180 + y + 226), 
											(int) (Math.cos( Math.toRadians(rotation+45) )*200), 
											(int) (Math.sin( Math.toRadians(rotation+45) )*200)) );

				tirs.add( new TirEnnemi(	(int) (Math.cos( Math.toRadians(rotation+20) )*180 + x + 226), 
											(int) (Math.sin( Math.toRadians(rotation+20) )*180 + y + 226), 
											(int) (Math.cos( Math.toRadians(rotation+10) )*200), 
											(int) (Math.sin( Math.toRadians(rotation+10) )*200)) );

				
				tirs.add( new TirEnnemi(	(int) (Math.cos( Math.toRadians(rotation+80) )*180 + x + 226), 
											(int) (Math.sin( Math.toRadians(rotation+80) )*180 + y + 226), 
											(int) (Math.cos( Math.toRadians(rotation+100) )*200), 
											(int) (Math.sin( Math.toRadians(rotation+100) )*200)) );

				tirs.add( new TirEnnemi(	(int) (Math.cos( Math.toRadians(rotation+50) )*180 + x + 226), 
											(int) (Math.sin( Math.toRadians(rotation+50) )*180 + y + 226), 
											(int) (Math.cos( Math.toRadians(rotation+55) )*200), 
											(int) (Math.sin( Math.toRadians(rotation+55) )*200)) );
				
				tirs.add( new TirEnnemi(	(int) (Math.cos( Math.toRadians(rotation+50) )*180 + x + 226), 
											(int) (Math.sin( Math.toRadians(rotation+50) )*180 + y + 226), 
											(int) (Math.cos( Math.toRadians(rotation+40) )*200), 
											(int) (Math.sin( Math.toRadians(rotation+40) )*200)) );
				
				tirs.add( new TirEnnemi(	(int) (Math.cos( Math.toRadians(rotation+20) )*180 + x + 226), 
											(int) (Math.sin( Math.toRadians(rotation+20) )*180 + y + 226), 
											(int) (Math.cos( Math.toRadians(rotation   ) )*200), 
											(int) (Math.sin( Math.toRadians(rotation   ) )*200)) );

				aTire = true;	
			}

			
			
			
			// TIRS DE LA PARTIE 4 VIVANTE
			if( ! partie4.isDead() && ( etat == 0 || etat == 3) )
			{
				for( int i=0; i<360; i+=40 )
				tirs.add( new TirEnnemi(	(int) (Math.cos( Math.toRadians(rotation+135) )*170 + x + 226), 
											(int) (Math.sin( Math.toRadians(rotation+135) )*170 + y + 226), 
											(int) (Math.cos( Math.toRadians(rotation+i) )*200), 
											(int) (Math.sin( Math.toRadians(rotation+i) )*200)) );
				aTire = true;
			}	
			
			
			
			// TIR DES PARTIES MORTES
			if( partie1.isDead() )
			{
				for( int i= - (int)rotation ; i<180 - (int)rotation; i+=45 )
					tirs.add( new TirEnnemi(	(int) (Math.cos( Math.toRadians(rotation+225) )*180 + x + 226), 
												(int) (Math.sin( Math.toRadians(rotation+225) )*180 + y + 226), 
												(int) (Math.cos( Math.toRadians(rotation+i) )*200), 
												(int) (Math.sin( Math.toRadians(rotation+i) )*200)) );
				aTire = true;
			}
			if( partie2.isDead() )
			{
				for( int i= - (int)rotation ; i<180 - (int)rotation; i+=25 )
					tirs.add( new TirEnnemi(	(int) (Math.cos( Math.toRadians(rotation+315) )*180 + x + 226), 
												(int) (Math.sin( Math.toRadians(rotation+315) )*180 + y + 226), 
												(int) (Math.cos( Math.toRadians(rotation+i) )*200), 
												(int) (Math.sin( Math.toRadians(rotation+i) )*200)) );
				aTire = true;
			}
			if( partie3.isDead() )
			{
				for( int i= - (int)rotation ; i<180 - (int)rotation; i+=40 )
					tirs.add( new TirEnnemi(	(int) (Math.cos( Math.toRadians(rotation+45) )*180 + x + 226), 
												(int) (Math.sin( Math.toRadians(rotation+45) )*180 + y + 226), 
												(int) (Math.cos( Math.toRadians(rotation+i) )*200), 
												(int) (Math.sin( Math.toRadians(rotation+i) )*200)) );
				aTire = true;
			}
			if( partie4.isDead() )
			{
				for( int i= - (int)rotation ; i<180 - (int)rotation; i+=30 )
					tirs.add( new TirEnnemi(	(int) (Math.cos( Math.toRadians(rotation+135) )*180 + x + 226), 
												(int) (Math.sin( Math.toRadians(rotation+135) )*180 + y + 226), 
												(int) (Math.cos( Math.toRadians(rotation+i) )*200), 
												(int) (Math.sin( Math.toRadians(rotation+i) )*200)) );
				aTire = true;
			}		
			
			
			// SI ON A TIRE JOUE UN SON
			if( aTire )
			{
				SonManager.getSonManager().jouerExpBoss();
				tirOk();
			}
		}
	}	
	
	
	
	
	
	/**
	 * Recupre la forme de l'ennemi
	 */	
	public Area getArea()
	{
		return new Area( new Ellipse2D.Double(x,y,452,452) );
	}	
	
	public Area getAreaCoeur()
	{
		Area a1 = new Area( new Ellipse2D.Double(x+150,y+150,200,200) );
		
		if( ! partie1.isDead() )
			a1.subtract( partie1.getArea() );
		if( ! partie2.isDead() )
			a1.subtract( partie2.getArea() );
		if( ! partie3.isDead() )
			a1.subtract( partie3.getArea() );
		if( ! partie3.isDead() )
			a1.subtract( partie3.getArea() );

		return a1;
	}	
	
	
	/**
	 * Ajoute les explosions
	 */
	protected void addExplosions()
	{
		Random r = new Random();
		
		// Points
		for( int i=0;i<80; i++ )
			exp.add( new ExplosionEnnemi( (int)x + (int)(r.nextFloat()*452 - 35 ), (int)y + (int)(r.nextFloat()*452 - 35 )) );	
		
		SonManager.getSonManager().jouerExplosionBig();
		SonManager.getSonManager().jouerExplosionBoss();
		
		Environnement.getEnvironnement().antiAliasing = antiAliasingSave;
	}	
	
	
	/**
	 * Ajoute les points dans un vecteur
	 */
	protected void addPoints()
	{
		Random r = new Random();
		
		// Autres points
		for( int i=0;i<60; i++ )
			it.add( new ItemPoint( 	getX()+50 + (int)(r.nextFloat()*302), 
									getY()+50 + (int)(r.nextFloat()*302),
									(int)(80 + 80 * r.nextFloat()),getPoints()/7) );	
		
		it.add( new   ItemTir( getX() + getWidth()/2 + 50, getY() + getHeight()/2 - 20,(int)(100)) );		
		it.add( new   ItemTir( getX() + getWidth()/2 - 50, getY() + getHeight()/2 - 20,(int)(100)) );			
		it.add( new ItemBombe( getX() + getWidth()/2     , getY() + getHeight()/2 + 20,(int)(100)) );	
		
	}	
	
	/**
	 * Mort du boss
	 */
	protected void die()
	{
		super.die();
		addExplosions();
		addPoints();
	}	
	
	/**
	 * Recupere les Explosions
	 */
	public Vector<Explosion> getExplosions()
	{
		exp.addAll( partie1.getExplosions() );
		exp.addAll( partie2.getExplosions() );
		exp.addAll( partie3.getExplosions() );
		exp.addAll( partie4.getExplosions() );
		partie1.clearExplosions();
		partie2.clearExplosions();
		partie3.clearExplosions();
		partie4.clearExplosions();
	
		return exp;
	}		
	
	
	/**
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * Collisions tirs
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 */
	public void collision( Tir t)
	{
		Area t1 = new Area( new Rectangle2D.Double( t.getX() , t.getY(), t.getWidth(), t.getHeight() ));
		Area a1 = getAreaCoeur();
		
		t1.intersect( a1 );
		
		if( ! t1.isEmpty() )
		{
			ennergie-= t.getForce();
			hit 	 = true;	
			t.explose();
			
			if( ennergie <=0 && it.size() == 0 )
				die();
		}		
		
        if( ! partie1.isDead() )
        	partie1.collision(t);
        if( ! partie2.isDead() )        
        	partie2.collision(t);
        if( ! partie3.isDead() )        
        	partie3.collision(t);
        if( ! partie4.isDead() )        
        	partie4.collision(t);	
	}
	
	
	/**
	 * Collisions bombre
	 */
	public void collision( Bombe b)
	{
		Area b1 = getAreaCoeur();
		Area t1 = b.getArea();
		Area t2 = b.getAreaInterne();
		
		t1.intersect(b1);
		t2.intersect(b1);
		
		if(  ! t1.isEmpty() && t2.isEmpty() && tempsImuniseBombe == 0)
		{
			ennergie		   -= b.getForce();
			hit		 			= true;
			tempsImuniseBombe 	= 600;
			
			SonManager.getSonManager().jouerExplosion();
			exp.add( new ExplosionEnnemi( (int)t1.getBounds().getCenterX(), (int) t1.getBounds().getMinY() - 100 ) );
			
			// SI mort on s'occupe des points et des explosions
			if( ennergie <=0 && it.size() == 0 )
				die();
		}
		
		
        if( ! partie1.isDead() )
        	partie1.collision(b);
        if( ! partie2.isDead() )        
        	partie2.collision(b);
        if( ! partie3.isDead() )        
        	partie3.collision(b);
        if( ! partie4.isDead() )        
        	partie4.collision(b);	
	}	
	
	
	/**
	 * Collision ennemi / laser
	 * @param i item
	 */	
	public boolean collision( Laser l )
	{
		boolean ok = false;
		
		Area b1 = getAreaCoeur();
		Area t1 = l.getArea();
		
		t1.intersect(b1);
		
		if( ! t1.isEmpty() )
		{
			if( tempsImuniseBombe <= 0 )
			{
				ennergie		   -= l.getForce();
				hit		 			= true;
				tempsImuniseBombe 	= l.getTempsImunise();	
			}
			
			l.setMaxY( (int)t1.getBounds2D().getCenterY() );
			
			SonManager.getSonManager().jouerExplosion();
			exp.add( new ExplosionEnnemi( (int)t1.getBounds().getCenterX(), (int) t1.getBounds().getMinY() - 100 ) );
			
			// SI mort on s'occupe des points et des explosions
			if( ennergie <=0 && it.size() == 0 )
				die();
			
			ok = true;
		}
		
		
		/* Faire les collisions dans le bon ordre */
		
		switch (etat) 
		{
			case 0:
		        if( 	( ! partie3.isDead() && partie3.collision(l) ) ||
		        		( ! partie4.isDead() && partie4.collision(l) ) ||      
		        		( ! partie1.isDead() && partie1.collision(l) ) ||    
		        		( ! partie2.isDead() && partie2.collision(l) ) 
		          )        
		        	ok = true;	
		        
				break;
			case 1:
		        if( 	( ! partie2.isDead() && partie2.collision(l) ) ||
		        		( ! partie3.isDead() && partie3.collision(l) ) ||      
		        		( ! partie4.isDead() && partie4.collision(l) ) ||  
		        		( ! partie1.isDead() && partie1.collision(l) ) 
		          )        
		        	ok = true;	
				break;
			case 2:
		        if( 	( ! partie1.isDead() && partie1.collision(l) ) ||
		        		( ! partie2.isDead() && partie2.collision(l) ) ||     
		        		( ! partie3.isDead() && partie3.collision(l) ) ||    
		        		( ! partie4.isDead() && partie4.collision(l) ) 
		          )        
		        	ok = true;	
				break;
			case 3:
		        if( 	( ! partie4.isDead() && partie4.collision(l) ) ||
		        		( ! partie1.isDead() && partie1.collision(l) ) ||     
		        		( ! partie2.isDead() && partie2.collision(l) ) ||    
		        		( ! partie3.isDead() && partie3.collision(l) ) 
		          )        
		        	ok = true;	
				break;
				
			default:
				break;
		}
		
		return ok;
	}			
	
	
	/**
	 * 
	 * 
	 * Refresh
	 * 
	 * 
	 * 
	 */
	public void refresh(long temps) 
	{
		if( y > -100)
		{
			vitesseX = 0;
			vitesseY = 0;
			
			// GESTION DES TIRS
			if( nombreCoup < nombreCoupParSalve )
			{
				delaisCoup += temps;
			}
			else
			{
				if( delaisSalve >= delaisEntreDeuxSalves )
				{
					delaisSalve = 0;
					nombreCoup = 0;
					delaisCoup = 0;
				}
				else
				{
					delaisSalve += temps;
				}
			}			
		
			gestionTirs();
		}
		
		
		super.refresh(temps);
		

		//GESTION DE LA ROTATION
		tempsAvantRotation -= temps;
		
		if( tempsAvantRotation <= 0)
			deplacementVersEtat = etat+1;
		
		// Si un changement d'etat a t demand
		if( deplacementVersEtat > -1 )
		{
			rotation += (80*temps)/1000.0;
		
			// Si le deplacement est ok, on le stabilise
			if( ( rotation >= deplacementVersEtat * 90 ) )
			{
				etat 				= deplacementVersEtat;
				rotation 			= deplacementVersEtat*90;
				deplacementVersEtat = -1;
				
				if( ( partie1.isDead() && etat == 2 ) ||  ( partie2.isDead() && etat == 1 ) ||  ( partie3.isDead() && etat == 4 ) ||  ( partie4.isDead() && etat == 3 ) )
					tempsAvantRotation 	= 500;
				else
					tempsAvantRotation 	= 7000;
			}
			
		}
		
		
		// remet en places les variables qui auraient pu depasser
		if( rotation >= 360)
			rotation -= 360;
		
		if( rotation < 0)
			rotation += 360;	
		
		etat = etat%4;
		
		
		
		//On met a jour l' etat des parties
		partie1.angle = rotation;
		partie2.angle = rotation;
		partie3.angle = rotation;
		partie4.angle = rotation;
		partie1.XBoss = partie2.XBoss = partie3.XBoss = partie4.XBoss = x;	
		partie1.YBoss = partie2.YBoss = partie3.YBoss = partie4.YBoss = y;	
		
		
		Environnement.getEnvironnement().items.addAll( partie1.getItems() );
		Environnement.getEnvironnement().items.addAll( partie2.getItems() );
		Environnement.getEnvironnement().items.addAll( partie3.getItems() );
		Environnement.getEnvironnement().items.addAll( partie4.getItems() );
		partie1.clearItems();
		partie2.clearItems();
		partie3.clearItems();
		partie4.clearItems();
	
		
		
		//On met a jour l' etat des  cannons
		cannons[0].angle = rotation+45;
		cannons[1].angle = rotation+135;
		cannons[2].angle = rotation+225;
		cannons[3].angle = rotation+315;
		cannons[0].XBoss = cannons[1].XBoss = cannons[2].XBoss = cannons[3].XBoss = x;	
		cannons[0].YBoss = cannons[1].YBoss = cannons[2].YBoss = cannons[3].YBoss = y;	
		
		
		
		// On fait le refresh des parties si elle ne sont pas mortes
		if( ! partie1.isDead() )
		{
			partie1.refresh(temps);
			
			// tourne la tourelle
			if( etat == 2 || etat == 3 || tourelle.etat != -1)
				tourelle.refresh(temps);
		}
		if( ! partie2.isDead() )
			partie2.refresh(temps);	
		if( ! partie3.isDead() )
			partie3.refresh(temps);	
		if( ! partie4.isDead() )
			partie4.refresh(temps);	
		

		
	}	
	
	
	
	/**
	 * 
	 * Shape
	 * 
	 */
	public void shape(Graphics graphics) 
	{
		if( temps >= 5000 )
		{
			if( vitesseY > 0 )
			{
		        BufferedImage bufferedImage = new BufferedImage(500, 500, BufferedImage.TYPE_INT_ARGB);
		        Graphics g 					= bufferedImage.createGraphics();
		        
				partie2.shape(g);
				partie3.shape(g);
				partie4.shape(g);
				partie1.shape(g);
				tourelle.shape(g);
					
				graphics.drawImage( bufferedImage , (int)x , (int)y , null);
			}
			else
			{
				// GESTION ROTATIONS
				BufferedImage imageRot		= new BufferedImage( 500,500, BufferedImage.TYPE_INT_ARGB);		
		        BufferedImage bufferedImage = new BufferedImage(500, 500, BufferedImage.TYPE_INT_ARGB);
		        Graphics2D g 					= bufferedImage.createGraphics();
				g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_OFF);
				g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_OFF);
				AffineTransform tx			= new AffineTransform();
				tx.rotate( ( Math.toRadians( rotation ) ), 226, 226);
				AffineTransformOp op 		= new AffineTransformOp(tx,  AffineTransformOp.TYPE_BILINEAR);		
		        
		        
		        
		        // AFFICHAGE DES PARTIES SI ELLES SONT MORTES
				if( partie1.isDead() )
					partie1.shape(g);
				if( partie2.isDead() )
					partie2.shape(g);
				if( partie3.isDead() )
					partie3.shape(g);
				if( partie4.isDead() )
					partie4.shape(g);
				
				
				
				
				// DESSINE LE COEUR
				float xTemp = x;
				float yTemp = y;
				y = x = -24;
				super.shape(g);
				x = xTemp;
				y = yTemp;
				
				
				
			
		        // AFFICHAGE DES PARTIES SI ELLES NE SONT PAS MORTES
		
				if( ! partie2.isDead() )
					partie2.shape(g);
				if( ! partie3.isDead() )
					partie3.shape(g);
				if( ! partie4.isDead() )
					partie4.shape(g);
				if( ! partie1.isDead() )
				{
					partie1.shape(g);
					tourelle.shape(g);
				}		
		
			
				// DESSINE LE BOSS
				op.filter(bufferedImage, imageRot);		
				graphics.drawImage( imageRot , (int)x , (int)y , null);
				
				
				
				
				// DESSINE LES CANNONS SI LA PARTIES SONT CASSEES
				if( partie3.isDead() )
					cannons[0].shape(graphics);
				if( partie4.isDead() )
					cannons[1].shape(graphics);
				if( partie1.isDead() )
					cannons[2].shape(graphics);
				if( partie2.isDead() )
					cannons[3].shape(graphics);
				
			}
		}
	}	
}

















////////////////////////////////
////////////////////////////////
///////////////////////////////
// PARTIES DU BOSS
////////////////////////////////
////////////////////////////////
///////////////////////////////



class Boss2Sub extends Ennemi
{
	public float angle;
	public float XBoss;
	public float YBoss;
	public ImageIcon img2;
	
	/**
	 * Constructeur
	 */
	public Boss2Sub( int i, int xx, int yy)
	{
		super( xx,yy,0,0,5000,700,0,0,300,30000,2);
		img = imgLoad.getBoss(i);
		img2= imgLoad.getBoss(i+4);
		bonus = ITEM_TIR;
	}
	
	/**
	 * retourne l'area de la partoe
	 * @return
	 */
	public Area getArea()
	{
		// Sphre autour du boss
		Area b1 = new Area( new   Ellipse2D.Double( XBoss		, YBoss		, 452 , 452 ));
		// Rectangle de la partie
		Area b2 = new Area( new Rectangle2D.Double( XBoss + x	, YBoss + y	, 226 , 226	));
		//On tourne le rectangle suivant l'angle du boss
		AffineTransform tx = new AffineTransform();
		tx.rotate((Math.toRadians(angle)), XBoss + 226, YBoss + 226);
		// on ne garde que l'arc de cercle contenu dans ce rectangle
		b1.intersect( b2 );
		// on tourne
		b1.transform(tx);
		return b1;
	}
	
	
	/**
	 * Mort de la partie
	 */
	public void die()
	{
		addPoints();
		addExplosions();
		
		SonManager.getSonManager().jouerExplosionBig();
		img = img2;
	}
	
	
	/**
	 * Add explosion !!!
	 */
	protected void addExplosions()
	{
		// Rectangle de la partie
		Area b2 = new Area( new Rectangle2D.Double( XBoss + x	, YBoss + y	, 226 , 226	));
		AffineTransform tx = new AffineTransform();
		tx.rotate((Math.toRadians(angle)), XBoss + 226, YBoss + 226);
		b2.transform(tx);
		Random r = new Random();
		
		// Exp
		for( int i=0;i<15; i++ )
			exp.add( new ExplosionEnnemi( b2.getBounds().x + (int)(r.nextFloat()*b2.getBounds().width - 35 ), b2.getBounds().y + (int)(r.nextFloat()*b2.getBounds().height - 35 )) );	
	}	
	
	
	/**
	 * Add point !!!
	 */
	protected void addPoints()
	{
		it.add( new ItemTir( (int)getArea().getBounds2D().getCenterX(),(int)getArea().getBounds2D().getCenterY(),150) );
	}
	
	
	/**
	 * Collsion entre un ennemi et un tir
	 * @param t
	 */
	public void collision( Tir t)
	{
		// AIRES
		Area t1 = new Area( new Rectangle2D.Double( t.getX() , t.getY(), t.getWidth(), t.getYPrededent() ));
		Area b1 = getArea();
		b1.intersect( t1 );

		// Si le tir est dans les intersections alors wala
		if( ! b1.isEmpty() )
		{
			ennergie-= t.getForce();
			hit		 = true;
			t.explose();
			
			// SI mort on s'occupe des points et des explosions
			if( ennergie <=0 && it.size() == 0 )
				die();
		}
	}	
	
	public void collision( Bombe b)
	{	
		Area b1 = getArea();
		Area t1 = b.getArea();
		Area t2 = b.getAreaInterne();
		
		t1.intersect(b1);
		t2.intersect(b1);
		
		if(  ! t1.isEmpty() && t2.isEmpty() && tempsImuniseBombe == 0)
		{
			ennergie		   -= b.getForce()/2;
			hit		 			= true;
			tempsImuniseBombe 	= 600;
			
			SonManager.getSonManager().jouerExplosion();
			exp.add( new ExplosionEnnemi( (int)t1.getBounds().getCenterX(), (int) t1.getBounds().getMinY() - 100 ) );
			
			// SI mort on s'occupe des points et des explosions
			if( ennergie <=0 && it.size() == 0 )
				die();
		}
	}
	
	public boolean collision( Laser l )
	{
		// AIRES
		Area t1 = l.getArea();
		Area b1 = getArea();
		b1.intersect( t1 );


		//Si il y a collision
		if( ! b1.isEmpty() )
		{
			l.setMaxY( (int)b1.getBounds2D().getMaxY() - l.getWidth()/4 - 5 );
			
			if( tempsImuniseBombe <= 0 )
			{
				ennergie		   -= l.getForce();
				hit		 			= true;
				tempsImuniseBombe 	= l.getTempsImunise();	
			}
		}
		else
			return false;
		
		// SI mort on s'occupe des points
		if( ennergie <=0 && it.size() == 0 )
			die();
		
		return true;
	}
}









/**
 * Cannons invincibles ne tournant pas sur eux-mme lorsque le boss tourne
 */
class Boss2Sub2 extends Ennemi
{
	public float angle;
	public float XBoss;
	public float YBoss;
	public Boss2Sub2(){super( 0,0,0,0,0,0,0,0,0,0,0);img = imgLoad.getBoss(9);}
	public Area getArea(){return new Area( new Rectangle2D.Double(0,0,0,0));}
	public void collision(Tir t){}	
	public void collision(Bombe b){}
	public void shape( Graphics graphics )
	{
		int ax = (int) (Math.cos( Math.toRadians(angle) )*180 + 226 - 24 );
		int ay = (int) (Math.sin( Math.toRadians(angle) )*180 + 226 - 24 );
		graphics.drawImage( img.getImage() , (int)XBoss + ax, (int)YBoss + ay, null);
	}
}







/**
 * tourelle invincible
 */
class Boss2Sub3 extends Ennemi
{
	public float 	angle = -45;
	public float 	XBoss;
	public float 	YBoss;
	
	public int 		etat 				= -1;
	public double 	tempsAvantRotation 	= 0;
	
	public Boss2Sub3(){super( 170,170,0,0,0,0,0,0,200,300,5);img = imgLoad.getBoss(10);}
	public Area getArea(){return new Area( new Rectangle2D.Double(0,0,0,0));}
	public void collision(Tir t){}	
	public void collision(Bombe b){}
	public void refresh( long temps )
	{
		// GESTION DES TIRS
		if( nombreCoup < nombreCoupParSalve )
		{
			delaisCoup += temps;
		}
		else
		{
			if( delaisSalve >= delaisEntreDeuxSalves )
			{
				delaisSalve = 0;
				nombreCoup = 0;
				delaisCoup = 0;
			}
			else
			{
				delaisSalve += temps;
			}
		}			
		
		if( tempsAvantRotation <=0 && etat == -1 )
		{
			etat = 1;
		}
		
		if( etat == 1 )
		{
			if( angle > -125 )
				angle -= (temps*70)/1000.0;
			else
				etat++;
		}
		
		if( etat == 2 )
		{
			if( angle < 35 )
				angle += (temps*70)/1000.0;
			else
				etat++;
		}
		
		if( etat == 3 )
		{
			if( angle > -45 )
				angle -= (temps*70)/1000.0;
			else
			{
				etat = -1;
				tempsAvantRotation = 1000;
			}
		}
		
		if( etat == -1 )
			tempsAvantRotation -= temps;
			
		
	}
	public void shape( Graphics graphics )
	{
		// GESTION ROTATIONS
		BufferedImage imageRot		= new BufferedImage( 452, 452, BufferedImage.TYPE_INT_ARGB);		
        BufferedImage bufferedImage = new BufferedImage( 452, 452, BufferedImage.TYPE_INT_ARGB);
        Graphics2D g 					= bufferedImage.createGraphics();
		g.setRenderingHint(RenderingHints.KEY_ANTIALIASING		, RenderingHints.VALUE_ANTIALIAS_OFF);
		g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING	, RenderingHints.VALUE_TEXT_ANTIALIAS_OFF);
        g.drawImage( imgLoad.getBoss(10).getImage(), 226, 226, null);
		AffineTransform tx			= new AffineTransform();
		tx.rotate( ( Math.toRadians( angle ) ), 42+226, 142+226);
		AffineTransformOp op 		= new AffineTransformOp(tx,  AffineTransformOp.TYPE_BILINEAR);		
  
		op.filter(bufferedImage, imageRot);	
		graphics.drawImage( imageRot , (int)x - 42 - 226, (int)y - 142 - 226, null);
	}	
}
