package elements.Ennemis.Boss;

import java.awt.AlphaComposite;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.geom.Area;
import java.awt.geom.Rectangle2D;
import java.awt.image.AffineTransformOp;
import java.awt.image.BufferedImage;
import java.util.Random;
import java.util.Vector;
import javax.swing.ImageIcon;

import controles.Environnement;
import controles.NiveauManager;
import controles.SonManager;
import elements.Ennemis.Ennemi;
import elements.Ennemis.EnnemiEvol1;
import elements.Ennemis.TankMed;
import elements.Explosions.ExplosionEnnemi;
import elements.Tirs.Bombe;
import elements.Tirs.Laser;
import elements.Tirs.Tir;
import elements.Tirs.TirEnnemi;
import elements.Tirs.TirEnnemiInvincible;
import elements.items.ItemBombe;
import elements.items.ItemPoint;
import elements.items.ItemTir;


/**
 * TOURELLE CIRCULAIRE DE DEFENSE D'UN WAGON
 * @author Jerome
 *
 */
class TourelleMitrail extends Tourelle
{	
	public TourelleMitrail(int xx,int yy)
	{
		super( xx, yy, 0 );
		
		delaisEntreDeuxCoups 	= 400;
		delaisEntreDeuxSalves 	= 1000;
		nombreCoupParSalve 		= 5;
		
		img  		= imgLoad.getBoss(4);
	}
	
	public void gestionTirs()
	{
		if( pretTirer() )
		{
			if( nombreCoup == 0)
			{
				tirs.add( new TirEnnemiInvincible( (int)x + decallage + 21 - 6 + nombreCoup*15, (int)y + 23 - 6, -60, 140 ) );
			}
			else if( nombreCoup == 4 )
			{
				tirs.add( new TirEnnemiInvincible( (int)x + decallage + 21 - 6 + nombreCoup*15, (int)y + 23 - 6, 60, 140 ) );
			}
			else
			{
				tirs.add( new TirEnnemiInvincible( (int)x + decallage + 21 - 6 + nombreCoup*15, (int)y + 23 - 6, 0, 200 ) );
			}
			tirOk();
		}
	}
	
	public void refresh( long temps )
	{
		super.refresh(temps);
	}	
	
	public void shape(Graphics graphics) 
	{
		graphics.drawImage( img.getImage(), (int)x + decallage , (int)y, null );
	}
}



/**
 * TOURELLE CIRCULAIRE DE DEFENSE D'UN WAGON
 * @author Jerome
 *
 */
class TourelleCirculaire extends Tourelle
{
	int vitesseRoatation;
	
	public TourelleCirculaire(int xx,int yy)
	{
		super( xx, yy, 0 );
		ennergie = 2000;
		
		delaisEntreDeuxCoups 	= 0;
		delaisEntreDeuxSalves 	= 350;
		nombreCoupParSalve 		= 1;
		vitesseRoatation 		= 35;
		
		img  		= imgLoad.getBoss(3);
	}
	
	public void gestionTirs()
	{
		if( pretTirer() && x < 712 )
		{
			tirs.add( new TirEnnemi( (int)x + decallage + getWidth()/2 - 6, 
									 (int)y + getHeight()/2 - 6, 
									 (int)(Math.cos( Math.toRadians(rotation) )*250), 
									 (int)(Math.sin( Math.toRadians(rotation) )*250) ) );
			
			tirs.add( new TirEnnemi( (int)x + decallage + getWidth()/2 - 6, 
					 				 (int)y + getHeight()/2 - 6, 
					 				 (int)(Math.cos( Math.toRadians(rotation+180) )*250), 
					 				 (int)(Math.sin( Math.toRadians(rotation+180) )*250) ) );
			
			tirOk();
		}
	}
	
	public void refresh( long temps )
	{
		y += (NiveauManager.getNiveauManager().getNiveau().getScrolling() * temps)/1000.0;
		
		rotation += (vitesseRoatation*temps)/1000.0;
		
		if( rotation >= 360)
			rotation -= 360;
		
		if( rotation < 0)
			rotation += 360;
	}	
	
	public void shape(Graphics graphics) 
	{
		graphics.drawImage( img.getImage(), (int)x + decallage , (int)y, null );
	}
}


/**
 * TOURELLE MOBILE DE DEFENSE D'UN WAGON
 * @author Jerome
 *
 */
class TourelleMobile extends Tourelle
{
	public TourelleMobile(int xx,int yy)
	{
		super(xx,yy,0);
	}
	
	public void refresh(long temps) 
	{
		super.refresh(temps);

		//GESTION DEPLACEMENT
		int valeurVitesseX = (int)x + decallage - Environnement.getEnvironnement().joueur.getX();
		int valeurVitesseY = (int)y - Environnement.getEnvironnement().joueur.getY();

		rotation = (int)Math.toDegrees( Math.acos(  Math.abs(valeurVitesseX)/(Math.sqrt( valeurVitesseX*valeurVitesseX + valeurVitesseY*valeurVitesseY)) ) );
		
		if( valeurVitesseX < 0 && valeurVitesseY < 0)
			rotation = rotation + 180;
		else if( valeurVitesseX < 0 && valeurVitesseY >= 0)
			rotation = 180 - rotation;
		else if( valeurVitesseX >= 0 && valeurVitesseY < 0)
			rotation = -rotation;
			
		rotation+=90;
	}	
}


class TourelleTirInvincible extends Tourelle
{
	public TourelleTirInvincible(int xx,int yy, int angle)
	{
		super(xx,yy,angle);
	}
	
	public void gestionTirs()
	{
		if( pretTirer() )
		{
			tirs.add( new TirEnnemiInvincible( getPointTirX(), getPointTirY() , getPointTirVitesseX(), getPointTirVitesseY() ) );
			tirOk();
		}
	}	
}

/**
 * TOURELLE DE DEFENSE D'UN WAGON
 * @author Jerome
 *
 */
class Tourelle extends Ennemi
{
	float rotation;
	int decallage;
	
	public Tourelle(int xx,int yy, int angle)
	{
		super(800,yy,0,0,650,200,2,0,200,2000,10);
		
		decallage = xx;
		
		img  		= imgLoad.getEnnemi(9);
		rotation 	= angle;
	}
	
	public void setPos( int xx ){x = xx;}	
	
	/**
	 * Recupre la position X du tir
	 * @return position X du tir
	 */	
	public int getPointTirX()
	{
		return (int) (Math.cos( Math.toRadians(rotation+90) )*26 + x + decallage + 5);
	}
	
	
	/**
	 * Recupre la position Y du tir
	 * @return position Y du tir
	 */
	public int getPointTirY()
	{
		return (int)(Math.sin( Math.toRadians(rotation+90) )*26 + y + 12);
	}	

	
	/**
	 * Recupre la vitesse en X du tir
	 * @return vitesse en X du tir
	 */	
	public int getPointTirVitesseX()
	{
		return (int) (Math.cos( Math.toRadians(rotation+90) )*(150 + vitesseX));
	}
	
	
	/**
	 * Recupre la vitesse en Y du tir
	 * @return vitesse en Y du tir
	 */
	public int getPointTirVitesseY()
	{
		return (int)(Math.sin( Math.toRadians(rotation+90) )*(150 + vitesseY));
	}
	
	
	public void gestionTirs()
	{
		if( pretTirer() )
		{
			tirs.add( new TirEnnemi( getPointTirX(), getPointTirY() , getPointTirVitesseX(), getPointTirVitesseY() ) );
			tirOk();
		}
	}	
	
	/**
	 * Rafraichi les coordonnes
	 */
	public void refresh(long temps) 
	{
		y += (NiveauManager.getNiveauManager().getNiveau().getScrolling() * temps)/1000.0;
	}	
	
	
	/**
	 * Dessine
	 */
	public void shape(Graphics graphics) 
	{
		//Cree un buffer vide
		BufferedImage imageRot= new BufferedImage( img.getImage().getWidth(null), img.getImage().getHeight(null), BufferedImage.TYPE_INT_ARGB);

		// Copie l'image dans un buffer
        BufferedImage bufferedImage = new BufferedImage(img.getImage().getWidth(null), img.getImage().getHeight(null), BufferedImage.TYPE_INT_ARGB);
        Graphics g = bufferedImage.createGraphics();
        g.drawImage(img.getImage(), 0, 0, null);
        g.dispose();

        // On tourne l'image dans le buffer
		AffineTransform tx = new AffineTransform();
		tx.rotate((Math.toRadians(rotation)),( img.getImage().getWidth(null) /2),( img.getImage().getHeight(null) )/2);
		AffineTransformOp op = new AffineTransformOp(tx,  AffineTransformOp.TYPE_BILINEAR);
	
		// On met l'image tourne dans ImageRot
		op.filter(bufferedImage, imageRot);
		 
		// On affiche
		graphics.drawImage( imageRot, (int)x -15 + decallage, (int)y - 12,null);
	}	
}






//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------




/**
 * WAGON 3
 * @author Jerome
 *
 */
class Wagon3 extends Wagon
{
	long tempsAvantProchainEnvoi;
	
	public Wagon3( int yy )
	{
		super( yy);
		
		armes = new Tourelle[9];

		armes[0] = new TourelleCirculaire( 295, yy+112);		
		
		armes[1] = new Tourelle( 210, yy+100, 20);
		armes[2] = new Tourelle( 380, yy+100, -20);
		armes[3] = new TourelleMobile( 295, yy+70);
		armes[4] = new TourelleMobile( 295, yy+130);
		
		armes[5] = new TourelleMitrail( 17, yy+25);
		armes[6] = new TourelleMitrail( 135, yy+25);
		armes[7] = new TourelleMitrail( 365, yy+25);
		armes[8] = new TourelleMitrail( 482, yy+25);
		
		tempsAvantProchainEnvoi = 20000;
	}
	
	public void refresh(long temps) 
	{
		super.refresh(temps);
		
		tempsAvantProchainEnvoi -= temps;
	}	
	
	public void gestionTirs()
	{
		super.gestionTirs();
		
		if( tempsAvantProchainEnvoi <= 0 )
		{
			tempsAvantProchainEnvoi = 40000;
		
			Environnement.getEnvironnement().ennemis.add( new EnnemiEvol1( 264 + 212, (int)y + 85, 0,  60, ITEM_TIR_ET_BOMBE )  );
		}
	}	
}



/**
 * WAGON 2
 * @author Jerome
 *
 */
class Wagon2 extends Wagon
{
	long tempsAvantProchainEnvoi;
	
	public Wagon2( int yy )
	{
		super( yy );
		
		armes = new Tourelle[5];

		armes[0] = new TourelleCirculaire( 	295, 	yy+112			);		
		
		armes[1] = new TourelleMobile( 		21, 	yy+25			);
		armes[2] = new TourelleTirInvincible( 			21, 	yy+196, 	-35	);
		
		armes[3] = new TourelleMobile( 		486, 	yy+25			);
		armes[4] = new TourelleTirInvincible( 			486, 	yy+196, 	35	);
		
		tempsAvantProchainEnvoi = 20000;
	}
	
	public void refresh(long temps) 
	{
		super.refresh(temps);
		
		tempsAvantProchainEnvoi -= temps;
	}	
	
	public void gestionTirs()
	{
		super.gestionTirs();
		
		if( tempsAvantProchainEnvoi <= 0 )
		{
			tempsAvantProchainEnvoi = 20000;
		
			Environnement.getEnvironnement().ennemis.add( new TankMed( 264 + 212, (int)y + 85, 60,  10, ITEM_TIR, 10000)  );
			Environnement.getEnvironnement().ennemis.add( new TankMed( 304 + 212, (int)y + 85, 60, -10, ITEM_BOMBE, 10000)  );
		}
	}	
}



/**
 * WAGON 1
 * @author Jerome
 *
 */
class Wagon1 extends Wagon
{
	public Wagon1( int yy )
	{
		super( yy);
		
		armes = new Tourelle[8];

		armes[0] = new TourelleCirculaire( 295, yy+112);		
		
		armes[1] = new Tourelle( 210, yy+100, 20);
		armes[2] = new Tourelle( 380, yy+100, -20);
		armes[3] = new Tourelle( 295, yy+70, 0);
		
		armes[4] = new TourelleMitrail( 20, yy+25);
		armes[5] = new TourelleMitrail( 138, yy+25);
		armes[6] = new TourelleMitrail( 368, yy+25);
		armes[7] = new TourelleMitrail( 485, yy+25);
	}
}



/**
 * 
 * 
 * WAGON DU BOSS
 * 
 * 
 * @author Jerome
 */
class Wagon extends Ennemi
{
	protected Tourelle[] armes;
	
	private ImageIcon img2;
	private ImageIcon img3;
	
	public Wagon( int yy )
	{
		super( 0,yy,0,0,25000,700,0,0,300,4000,2);
		img  = imgLoad.getBoss(1);
		img2 = imgLoad.getBoss(0);
		img3 = imgLoad.getBoss(2);
		
		armes = new Tourelle[0];
	}
	
	public void setPos( int xx )
	{
		for( int i=0; i < armes.length; i++ )
			armes[i].setPos( xx );
		
		x = xx;
	}
	
	public Area getArea()
	{
		return new Area( new Rectangle2D.Double(x+179,y+77,250,90) );
	}
	
	/**
	 * 
	 * GERE LA ROUTINE DES TIRS
	 * 
	 */
	public void gestionTirs()
	{
		for( int i=0; i < armes.length; i++ )
			armes[i].gestionTirs();
	}	

	
	
	/**
	 * Recupere les tirs
	 * @return tirs
	 */
	public Vector<TirEnnemi> getTirs()
	{
		for( int i=0; i < armes.length; i++ )
		{
			tirs.addAll( armes[i].getTirs() );
			armes[i].clearTirs();
		}

		return tirs;
	}	
	
	public void die()
	{
		super.die();
		ennergie = 0;
	}
	
	public void collision( Tir t )
	{
		Area a1 = getArea();
			
		Area t1 = new Area( new Rectangle2D.Double(t.getX(),t.getY(),t.getWidth(),t.getHeight()) );
		
		t1.intersect(a1);

		if(  ! t1.isEmpty() )
		{
			if( y>0 )
			{
				ennergie-= t.getForce();
				hit = true;
			}
			t.explose();
			
			// SI mort on s'occupe des points
			if( ennergie <=0 && it.size() == 0 )
				die();
		}
	}	
	
	public void refreshTirs(long temps) 
	{
		for( int i=0; i < armes.length; i++ )
			armes[i].refreshTirs(temps);	
	}
	
	public void refresh(long temps) 
	{
		if( tempsImuniseBombe > 0)
			tempsImuniseBombe -= temps;
		
		if( tempsImuniseBombe < 0 )
			tempsImuniseBombe = 0;
		
		y += (NiveauManager.getNiveauManager().getNiveau().getScrolling() * temps)/1000.0;
		
		for( int i=0; i < armes.length; i++ )
			armes[i].refresh(temps) ;
	}	
	
	public void shape(Graphics graphics) 
	{
		graphics.drawImage( img2.getImage(), (int)x, (int)y, null );
		
		if( ennergie >0 )
		{
			if( hit && Environnement.getEnvironnement().effects == 1)
			{
				graphics.drawImage( img3.getImage(), (int)x+179, (int)y+77, null );
				hit = false;
			}
			else
			{
				graphics.drawImage( img.getImage(), (int)x+179, (int)y+77, null );		
			}
			
			for( int i=0; i < armes.length; i++ )
				armes[i].shape(graphics);	
		}
	}
}


//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------



/**
 * 
 * 
 * BOSS DU NIVEAU 3
 * 
 * 
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class Boss3 extends Boss
{
	private int deplacementEnCours = 1;
	private int position = 0;
	private int tempsAvantAcceleration = 0;
	
	private Wagon wagon1;
	private Wagon wagon2;
	private Wagon wagon3;	
	
	/**
	 * Constructeur
	 */
	public Boss3()
	{
		super( 800 ,-500,0,0,75000,0,100,0,400,2000,4);
		
		img  = imgLoad.getEnnemi(12);
		
		wagon1 	= new Wagon1((int)y);
		wagon2 	= new Wagon2((int)y);
		wagon3 	= new Wagon3((int)y);		
	}
	

	/**
	 * 
	 * GERE LA ROUTINE DES TIRS
	 * 
	 */
	public void gestionTirs()
	{
		if( deplacementEnCours == 0 )
		{
			if( position == 1 )		
				wagon1.gestionTirs();
	
			if( position == 2 )		
				wagon2.gestionTirs();
	
			if( position == 3 )		
				wagon3.gestionTirs();
		}
	}	

	
	
	/**
	 * Recupere les tirs
	 * @return tirs
	 */
	public Vector<TirEnnemi> getTirs()
	{
		if( position == 1 )
		{
			tirs.addAll( wagon1.getTirs() );
			wagon1.clearTirs();
		}
		
		if( position == 2 )
		{
			tirs.addAll( wagon2.getTirs() );
			wagon2.clearTirs();
		}
		
		if( position == 3 )
		{
			tirs.addAll( wagon3.getTirs() );
			wagon3.clearTirs();
		}

		return tirs;
	}	
	

	/**
	 * Collsion entre un ennemi et un tir
	 * @param t
	 */
	public void collision( Tir t)
	{
		if( deplacementEnCours == 0 )
		{
			if( position == 1 )		
				wagon1.collision(t);

			if( position == 2 )		
				wagon2.collision(t);

			if( position == 3 )		
				wagon3.collision(t);
		}
	}	
	

	/**
	 * Collsion entre un ennemi et un tir
	 * @param t
	 */
	public void collision( Bombe b)
	{
		if( deplacementEnCours == 0 )
		{
			if( position == 1 )		
				wagon1.collision(b);

			if( position == 2 )		
				wagon2.collision(b);

			if( position == 3 )		
				wagon3.collision(b);
		}
	}	
		
	
	/**
	 * Collision ennemi / laser
	 * @param i item
	 */	
	public boolean collision( Laser l )
	{
		boolean ok = false;

		if( deplacementEnCours == 0 )
		{		
			if( wagon1.collision(l) && position == 1 )	
				ok = true;	
			if( wagon2.collision(l) && position == 2 )	
				ok = true;			
			if( wagon3.collision(l) && position == 3 )	
				ok = true;		
		}
		
		return ok;
	}			
	
	
	/**
	 * Recupre la forme de l'ennemi
	 */	
	public Area getArea()
	{
		return new Area( new Rectangle2D.Double(x+185,y+85,getWidth(),getHeight()) );
	}	
	
	
	
	/**
	 * Ajoute les explosions
	 */
	protected void addExplosions()
	{
		Random r = new Random();
		
		// Exposions
		for( int i=0;i<60; i++ )
			exp.add( new ExplosionEnnemi( (int)(212 + r.nextFloat()*600) , (int) 50 + (int)(r.nextFloat()*200) ) );	
		
		// Exposions
		for( int i=0;i<20; i++ )
			exp.add( new ExplosionEnnemi( (int)(212 + 225 + r.nextFloat()*250) , (int) 100 + 80 + (int)(r.nextFloat()*100) ) );	
		
		SonManager.getSonManager().jouerExplosionBig();
		SonManager.getSonManager().jouerExplosionBoss();
	}	
	
	
	/**
	 * Ajoute les points dans un vecteur
	 */
	protected void addPoints()
	{
		Random r = new Random();
		
		// Autres points
		for( int i=0;i<60; i++ )
			Environnement.getEnvironnement().items.add( new ItemPoint( 	300 + (int)(r.nextFloat()*440), 
									100 + (int)(r.nextFloat()*250),
									(int)(80 + 80 * r.nextFloat()),1000) );	
		
		Environnement.getEnvironnement().items.add( new   ItemTir( 512  + 50, 150 - 20,(int)(100)) );		
		Environnement.getEnvironnement().items.add( new   ItemTir( 512  - 50, 150 - 20,(int)(100)) );			
		Environnement.getEnvironnement().items.add( new ItemBombe( 512      , 150 + 20,(int)(100)) );	
		
	}	
	
	/**
	 * Mort du boss
	 */
	protected void die()
	{
		super.die();
		addPoints();
		NiveauManager.getNiveauManager().getNiveau().setScrolling( 90 );
		Environnement.getEnvironnement().tirsEnnemi = new Vector<TirEnnemi>(0);
		Environnement.getEnvironnement().score += 8000;
	}	
	
	
	public boolean isDead()
	{
		return y > 800;
	}

	
	public void gestionDeplacements( long temps, int decallage )
	{
		// DEPART
		if( position < 4 )
		{
			// SI BOUGE
			if( deplacementEnCours == 1 )
			{
				// TANT QUE VITESSE N'EST PAS MAX
				if( vitesseX > -100 )
				{
					// ACCELERE
					if( vitesseX == 0 )
					{
						vitesseX = -3;
					}
					else
					{
						if( tempsAvantAcceleration > 0 )
						{
							tempsAvantAcceleration-=temps;
						}
						else
						{
							vitesseX *= 1.2;
							tempsAvantAcceleration = 150;
						}
						
					}	
				}

				// UNE FOIS AU BOUT STOP
				if( x <= 282 - decallage )
				{
					vitesseX = -(x-200+decallage);
					
					if( x <= 212-decallage )
					{
						x = 212-decallage;
						position++;
						deplacementEnCours = 0;
						vitesseX = 0;
					}
				}
			}
		}
	}
	
	
	/**
	 * 
	 * 
	 * Refresh
	 * 
	 * 
	 * 
	 */
	public void refresh( long t ) 
	{
		// REFRESH D'UN BOSS
		if( temps < 5000 )
		{
			temps+=t;
			SonManager.getSonManager().jouerWarning();
		}
		else
		{
			// REFRESH D'UN ENNEMI
			x += (vitesseX*t)/1000.0;
			
			if( tempsImuniseBombe > 0)
				tempsImuniseBombe -= t;
			
			if( tempsImuniseBombe < 0 )
				tempsImuniseBombe = 0;

			// Si l'ennemi est a l'ecran
			if( y > 0)
				refreshTirs( t );
			
			
			SonManager.getSonManager().jouerMusique();
			
			/* Drop un <P> tous les 33% de la barre du boss */
			if( ( (ennergie/(float)ennergieMax) < itemTirADropper*0.33 ) && ennergie > 0)
			{
				SonManager.getSonManager().jouerExplosionBig();
				Environnement.getEnvironnement().exps.add( new ExplosionEnnemi( (int)getArea().getBounds2D().getCenterX(), (int)getArea().getBounds2D().getCenterY()));
				Environnement.getEnvironnement().items.add( new ItemTir( (int)getArea().getBounds2D().getCenterX(), (int)getArea().getBounds2D().getCenterY(), 150 ));
				itemTirADropper--;
			}
			
		}
		
		// GERE DEPLACEMENT
		
		if( position == 0 && y > 100)
		{
			y = 100;
			NiveauManager.getNiveauManager().getNiveau().setScrolling(0);
		}
		else
		{
			gestionDeplacements( t, position*600 );
		}
		
		y += ( NiveauManager.getNiveauManager().getNiveau().getScrolling() * t )/1000.0;	
		
		wagon1.refresh(t);
		wagon1.setPos((int)x);
		
		wagon2.refresh(t);
		wagon2.setPos((int)x+600);
		
		wagon3.refresh(t);
		wagon3.setPos((int)x+1200);
		
		if( position == 1 && deplacementEnCours == 0 )
		{
			wagon1.refreshTirs(t);
			
			if( wagon1.isDead() )
			{
				SonManager.getSonManager().jouerExplosionBig();
				exp.add( new ExplosionEnnemi(getX() + getWidth()/2 ,getY() - 70 ) );
				deplacementEnCours = 1;
				addExplosions();
			}
		}
		
		if( position == 2 && deplacementEnCours == 0 )
		{
			wagon2.refreshTirs(t);
			
			if( wagon2.isDead() )
			{
				SonManager.getSonManager().jouerExplosionBig();
				exp.add( new ExplosionEnnemi(getX() + getWidth()/2 ,getY() - 70 ) );
				deplacementEnCours = 1;
				addExplosions();
			}
		}
		
		if( position == 3 && deplacementEnCours == 0 )
		{
			wagon3.refreshTirs(t);
			
			if( wagon3.isDead() )
			{
				SonManager.getSonManager().jouerExplosionBig();
				exp.add( new ExplosionEnnemi(getX() + getWidth()/2 ,getY() - 70 ) );
				deplacementEnCours = 1;
				
				die();
				addExplosions();
				

			}
		}
		
		ennergie = wagon1.getEnnergie() + wagon2.getEnnergie() + wagon3.getEnnergie();
	}	
	

	/**
	 * Dessine
	 */
	public void shape(Graphics graphics) 
	{
		graphics.drawImage( img.getImage(), 212, (int)y + 26, null );
		graphics.drawImage( img.getImage(), 212, (int)y + 200, null );
		
		
		if( deplacementEnCours == 0 )
		{
			if( position == 1 )
			{
				wagon1.shape(graphics);		
			}			
			else if( position == 2 )
			{
				wagon2.shape(graphics);		
			}			
			else if( position == 3 )
			{
				wagon3.shape(graphics);		
			}
		}
		else
		{
			if( position == 0 )
			{
				wagon1.shape(graphics);		
			}		
			else if( position == 1 )
			{
				wagon1.shape(graphics);	
				wagon2.shape(graphics);	
			}			
			else if( position == 2 )
			{
				wagon2.shape(graphics);		
				wagon3.shape(graphics);		
			}			
			else if( position == 3 )
			{
				wagon3.shape(graphics);		
			}
		}			
	}	
	
	/**
	 * AFFICHAGE FOREGORUND
	 * @param graphics graphics
	 */
	public void shapeForeground( Graphics graphics )
	{
		if( temps < 5000 )
		{
			
			float alpha;
			
			// Modifie l'alpha
			if( temps < 2000 || ( temps > 2500 && temps < 4000 ) )
				alpha = (float)((temps)%2500/2000.0f);	
			else
				alpha = (float)( (1 - (temps%2500-2500) )/1000 );
			
			// Evite les bugs d'alpha
			if( alpha > 1 )
				alpha = 1;
			if( alpha < 0 )
				alpha = 0;
			
			
			// AFFICHAGE DU WARNING
			Graphics2D g = (Graphics2D) graphics;
			g.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, alpha ));	
			g.drawImage( imgLoad.getStaut(5).getImage(), 512 - imgLoad.getStaut(5).getIconWidth()/2, 300, null );
			g.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 1f ));	
			
		}

		if( ennergie > 0 )
		{
			// AFFICHAGE DE LA BARRE D'ENNERGIE
			int ennergieRest = ennergie*534/ennergieMax; 
		
			Graphics2D graphics2d = ((Graphics2D)graphics);
		
			graphics2d.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.1f ));
				graphics2d.setStroke( new BasicStroke( 6f ) );
					graphics2d.setColor( Color.yellow );
					graphics2d.drawRect(245, 693, ennergieRest, 2);
				graphics2d.setStroke( new BasicStroke() );
			graphics2d.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 1f ));	
			
			graphics2d.setColor( Color.black );		
			graphics2d.drawRect(242, 690, 1024-242*2, 8);	
		}
				
	}
}



