package elements.Ennemis;

import java.awt.geom.Area;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Rectangle2D;
import elements.Tirs.TirEnnemiInvincible;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 * 
 * Ennemi se deplacant sur le cote
 *
 */
public class EnnemiEvol5 extends Ennemi
{
	private static final long serialVersionUID = 1L;

	private int vX;
	
	/**
	 * Constructeur
	 * @param xx x
	 * @param yy y
	 * @param vx vitesseX
	 * @param vy vitesseY
	 * @param il imageLoader
	 */	
	public EnnemiEvol5(int xx,int yy, int vx, int vy,int b)
	{
		super(xx,yy,0,vy,150,200,1,b,0,400,1);
		img = imgLoad.getEnnemi(7);
		vX = vx;
	}
	
	public void gestionTirs()
	{
		if( pretTirer() )
		{
			tirs.add( new TirEnnemiInvincible( (int)x + 20	, (int)y  , 0, -250 ) );
			tirOk();
		}
	}	
	
	/**
	 * Refresh
	 */
	public void refresh( long temps )
	{
		if( y > 640 && vitesseX == 0)
		{
			vitesseX = vX;
			vitesseY = 0;
		}
		
		super.refresh(temps);
	}

	/**
	 * Recupre la forme de l'ennemi
	 */	
	public Area getArea()
	{
		Area a1 = new Area( new Ellipse2D.Double(x,y-60,55,79) );
		a1.subtract( new Area(new Rectangle2D.Double(x,y-60,55,65)) );
		
		return a1;
	}	
}
