package elements.Ennemis;

import java.awt.Graphics;
import java.awt.geom.Area;
import java.awt.geom.Ellipse2D;
import elements.Tirs.TirEnnemiInvincible;


/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class EnnemiMine extends Ennemi
{
	private static final long serialVersionUID = 1L;
	private int stopLimit;

	
	/**
	 * Constructeur
	 * @param xx x
	 * @param yy y
	 * @param vx vitesseX
	 * @param vy vitesseY
	 * @param strop position d'arret du vaisseau
	 * @param il imageLoader
	 */
	public EnnemiMine(int xx,int yy, int vx, int vy, int b, int stop)
	{
		super(xx,yy,vx,vy,100,500,4,b,0,0,0);
		
		stopLimit = stop;
		
		img  = imgLoad.getEnnemi(6);
	}

	
	/**
	 * Recupre la position X du tir
	 * @return position X du tir
	 */	
	public int getPointTirX( int angle, int position )
	{
		return (int) (Math.cos( Math.toRadians(angle) )*position + x + 24);
	}
	
	
	/**
	 * Recupre la position Y du tir
	 * @return position Y du tir
	 */
	public int getPointTirY( int angle, int position )
	{
		return (int)(Math.sin( Math.toRadians(angle) )*position + y + 24);
	}	

	
	/**
	 * Recupre la vitesse en X du tir
	 * @return vitesse en X du tir
	 */	
	public int getPointTirVitesseX( int angle )
	{
		return (int) (Math.cos( Math.toRadians(angle) )*300);
	}
	
	
	/**
	 * Recupre la vitesse en Y du tir
	 * @return vitesse en Y du tir
	 */
	public int getPointTirVitesseY( int angle)
	{
		return (int)(Math.sin( Math.toRadians(angle) )*300);
	}
	
	
	public void gestionTirs()
	{

	}	

	
	/**
	 * Recupre la forme de l'ennemi
	 */	
	public Area getArea()
	{
		return new Area( new Ellipse2D.Double(x,y,getWidth(),getHeight()) );
	}	
	
	public void die()
	{
		super.die();
		explose();
	}
	
	
	/**
	 * Tue l'ennemi
	 */
	public void explose()
	{
		for( int i=0;i<360;i+=50)
			tirs.add( new TirEnnemiInvincible( getPointTirX(i,2), getPointTirY(i,2) , getPointTirVitesseX(i), getPointTirVitesseY(i) ) );

		for( int i=10;i<360;i+=50)
			tirs.add( new TirEnnemiInvincible( getPointTirX(i,15), getPointTirY(i,15) , getPointTirVitesseX(i), getPointTirVitesseY(i)) );
		
		ennergie = 0;
	}
	
	/**
	 * Collsion entre un ennemi et un tir
	 * @param t

	public void collision( Tir t)
	{
		if
		( 	
				t.getX() + t.getWidth()*2  	>= x+15 && 
				t.getX() - t.getWidth()		<= x+img.getImage().getWidth(null)-15 && 
				( 
						( t.getY() < y+15 && t.getYPrededent() > y+img.getImage().getHeight(null)-10 ) || 
						( t.getY() > y+15 && t.getY() < y+img.getImage().getHeight(null)-10 )
				) 
		)
			
			
		{
			if( y>0 )
				ennergie-= t.getForce();

			// SI mort on s'occupe des points
			if( ennergie <=0 && it.size() == 0 )
				die();
			
			t.explose();
		}
	}	
	
	/**
	 * Collision ennemi / player
	 * @param i item
	 *	
	public void collision( Bombe b )
	{
		super.collision(b);
		if( ennergie <= 0 )
			die();	
		
		// SI mort on s'occupe des points
		if( ennergie <=0 && it.size() == 0 )
			addPoints();
	}
	*/
	
	/**
	 * Rafraichi les coordonnes
	 */
	public void refresh(long temps) 
	{
		if( y > stopLimit)
		{
			vitesseX = 0;
			vitesseY = 0;
		}
		
		super.refresh(temps);
	}	
	
	
	/**
	 * Dessine
	 */
	public void shape(Graphics graphics) 
	{
		super.shape(graphics);		
	}	
	
}