package elements.Ennemis;

import java.awt.Graphics;
import java.awt.geom.AffineTransform;
import java.awt.geom.Area;
import java.awt.geom.Rectangle2D;
import java.awt.image.AffineTransformOp;
import java.awt.image.BufferedImage;
import java.util.Vector;

import javax.swing.ImageIcon;

import controles.Environnement;
import controles.ImageManager;
import controles.NiveauManager;
import controles.SonManager;
import elements.Explosions.ExplosionEnnemi;
import elements.Tirs.Bombe;
import elements.Tirs.Laser;
import elements.Tirs.Tir;
import elements.Tirs.TirEnnemi;
import elements.Tirs.TirEnnemiInvincible;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */

class WagonCirc extends Wagon
{
	float rotation;
	int vitesseRoatation;
	
	public WagonCirc(int yy)
	{
		super( yy, ImageManager.getImagemanager().getEnnemi(16) );
		ennergie = 2000;
		
		delaisEntreDeuxCoups 	= 0;
		delaisEntreDeuxSalves 	= 350;
		nombreCoupParSalve 		= 1;
		vitesseRoatation 		= 35;
	}
	
	public void gestionTirs()
	{
		if( pretTirer() && x < 712 )
		{
			tirs.add( new TirEnnemi( (int)x + getWidth()/2 - 6, 
									 (int)y + getHeight()/2 - 6, 
									 (int)(Math.cos( Math.toRadians(rotation) )*250), 
									 (int)(Math.sin( Math.toRadians(rotation) )*250) ) );
			
			tirs.add( new TirEnnemi( (int)x + getWidth()/2 - 6, 
					 				 (int)y + getHeight()/2 - 6, 
					 				 (int)(Math.cos( Math.toRadians(rotation+180) )*250), 
					 				 (int)(Math.sin( Math.toRadians(rotation+180) )*250) ) );
			
			tirOk();
		}
	}
	
	public void refresh( long temps )
	{
		super.refresh(temps);
		
		rotation += (vitesseRoatation*temps)/1000.0;
		
		if( rotation >= 360)
			rotation -= 360;
		
		if( rotation < 0)
			rotation += 360;
	}
}

class WagonTank extends Wagon
{
	private int rotation;
	private int rotation2;
	
	private ImageIcon img2;
	
	public WagonTank(int yy)
	{
		super( yy, ImageManager.getImagemanager().getEnnemi(15) );
		ennergie = 2000;
		
		delaisEntreDeuxCoups 	= 300;
		delaisEntreDeuxSalves 	= 2000;
		nombreCoupParSalve 		= 7;
		
		img2 = imgLoad.getEnnemi(9);	
	}
	

	public void gestionTirs()
	{
		if( pretTirer() )
		{
			tirs.add( new TirEnnemi( (int)(Math.cos( Math.toRadians(rotation+90) )*26 + x + 5), 
									 (int)(Math.sin( Math.toRadians(rotation+90) )*26 + y + 12), 
									 (int)(Math.cos( Math.toRadians(rotation+90) )*(150)),
									 (int)(Math.sin( Math.toRadians(rotation+90) )*(150)) ));
			
			tirs.add( new TirEnnemi( (int)(Math.cos( Math.toRadians(rotation2+90) )*26 + x - 20 + getWidth()), 
					 				 (int)(Math.sin( Math.toRadians(rotation2+90) )*26 + y + 12), 
					 				 (int)(Math.cos( Math.toRadians(rotation2+90) )*(150)),
					 				 (int)(Math.sin( Math.toRadians(rotation2+90) )*(150)) ));			
			tirOk();
		}
	}	
	
	public void refresh( long temps )
	{
		super.refresh(temps);
		
		//GESTION DEPLACEMENT
		int valeurVitesseX = (int)x + 5 - Environnement.getEnvironnement().joueur.getX();
		int valeurVitesseY = (int)y + 5 - Environnement.getEnvironnement().joueur.getY();
		
		int valeurVitesseX2 = (int)x - 20 + getWidth() - Environnement.getEnvironnement().joueur.getX();
		int valeurVitesseY2 = (int)y - 20 + getWidth() - Environnement.getEnvironnement().joueur.getY();

		rotation = (int)Math.toDegrees( Math.acos(  Math.abs(valeurVitesseX)/(Math.sqrt( valeurVitesseX*valeurVitesseX + valeurVitesseY*valeurVitesseY)) ) );
		if( valeurVitesseX < 0 && valeurVitesseY < 0)
			rotation = rotation + 180;
		else if( valeurVitesseX < 0 && valeurVitesseY >= 0)
			rotation = 180 - rotation;
		else if( valeurVitesseX >= 0 && valeurVitesseY < 0)
			rotation = -rotation;
			
		rotation+=90;
		
		rotation2 = (int)Math.toDegrees( Math.acos(  Math.abs(valeurVitesseX2)/(Math.sqrt( valeurVitesseX2*valeurVitesseX2 + valeurVitesseY2*valeurVitesseY2)) ) );
		if( valeurVitesseX2 < 0 && valeurVitesseY2 < 0)
			rotation2 = rotation2 + 180;
		else if( valeurVitesseX2 < 0 && valeurVitesseY2 >= 0)
			rotation2 = 180 - rotation2;
		else if( valeurVitesseX2 >= 0 && valeurVitesseY2 < 0)
			rotation2 = -rotation2;
			
		rotation2+=90;		
	}
	
	public void shape(Graphics graphics) 
	{
		super.shape(graphics);
		
		//Cree un buffer vide
		BufferedImage imageRot= new BufferedImage( img2.getImage().getWidth(null), img2.getImage().getHeight(null), BufferedImage.TYPE_INT_ARGB);

		// Copie l'image dans un buffer
        BufferedImage bufferedImage = new BufferedImage(img2.getImage().getWidth(null), img2.getImage().getHeight(null), BufferedImage.TYPE_INT_ARGB);
        Graphics g = bufferedImage.createGraphics();
        g.drawImage(img2.getImage(), 0, 0, null);
        g.dispose();

        // On tourne l'image dans le buffer
		AffineTransform tx = new AffineTransform();
		tx.rotate((Math.toRadians(rotation)),( img2.getImage().getWidth(null) /2),( img2.getImage().getHeight(null) )/2);
		AffineTransformOp op = new AffineTransformOp(tx,  AffineTransformOp.TYPE_BILINEAR);
	
		// On met l'image tourne dans ImageRot
		op.filter(bufferedImage, imageRot);
		 
		// On affiche
		graphics.drawImage( imageRot, (int)x -15, (int)y - 12,null);
		
		
		//Cree un buffer vide
		imageRot= new BufferedImage( img2.getImage().getWidth(null), img2.getImage().getHeight(null), BufferedImage.TYPE_INT_ARGB);

		// Copie l'image dans un buffer
        bufferedImage = new BufferedImage(img2.getImage().getWidth(null), img2.getImage().getHeight(null), BufferedImage.TYPE_INT_ARGB);
        g = bufferedImage.createGraphics();
        g.drawImage(img2.getImage(), 0, 0, null);
        g.dispose();

        // On tourne l'image dans le buffer
		tx = new AffineTransform();
		tx.rotate((Math.toRadians(rotation2)),( img2.getImage().getWidth(null) /2),( img2.getImage().getHeight(null) )/2);
		op = new AffineTransformOp(tx,  AffineTransformOp.TYPE_BILINEAR);
	
		// On met l'image tourne dans ImageRot
		op.filter(bufferedImage, imageRot);
		 
		// On affiche
		graphics.drawImage( imageRot, (int)x -40 + getWidth(), (int)y - 12,null);		
	}		
}

class WagonArme extends Wagon
{
	public WagonArme(int yy)
	{
		super( yy, ImageManager.getImagemanager().getEnnemi(14) );
		ennergie = 2000;
		
		delaisEntreDeuxCoups 	= 400;
		delaisEntreDeuxSalves 	= 1000;
		nombreCoupParSalve 		= 5;
	}
	
	public void gestionTirs()
	{
		if( pretTirer() && x < 712 )
		{
			if( nombreCoup == 0)
			{
				tirs.add( new TirEnnemiInvincible( (int)x + 21 - 6 + nombreCoup*15, (int)y + 23 - 6, -60, 140 ) );
			}
			else if( nombreCoup == 4 )
			{
				tirs.add( new TirEnnemiInvincible( (int)x + 21 - 6 + nombreCoup*15, (int)y + 23 - 6, 60, 140 ) );
			}
			else
			{
				tirs.add( new TirEnnemiInvincible( (int)x + 21 - 6 + nombreCoup*15, (int)y + 23 - 6, 0, 200 ) );
			}
			tirOk();
		}
	}
}

class Locomotive extends Wagon
{
	public Locomotive(int yy)
	{
		super( yy, ImageManager.getImagemanager().getEnnemi(13) );
		ennergie = 3000;
	}
}

class Wagon extends Ennemi
{
	public Wagon( int yy, ImageIcon im )
	{
		super( 0,yy,0,0,1500,700,0,0,300,4000,2);
		img = im;
	}
	
	public void setPos( int xx ){x = xx;}
	
	public void refresh(long temps) 
	{
		if( tempsImuniseBombe > 0)
			tempsImuniseBombe -= temps;
		
		if( tempsImuniseBombe < 0 )
			tempsImuniseBombe = 0;
		
		if( y > 0)
			refreshTirs( temps );

		if( ennergie <= 0 )
		{
			SonManager.getSonManager().jouerExplosionBig();
			exp.add( new ExplosionEnnemi(getX() + getWidth()/2 ,getY() - 70 ) );
		}
		
		y += (NiveauManager.getNiveauManager().getNiveau().getScrolling() * temps)/1000.0;
	}		
}









/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class Train extends Ennemi
{
	private static final long serialVersionUID = 1L;

	private Locomotive loco;
	
	private Wagon wagon1;
	private Wagon wagon2;
	private Wagon wagon3;
	

	
	/**
	 * Constructeur
	 * @param xx x
	 * @param yy y
	 * @param angleDept angle de depart
	 * @param angle angle de deplacement
	 * @param tempsDepl temps du deplacement
	 * @param b bonus
	 */
	public Train( int xx, int yy, int vx, int b)
	{
		super(xx,yy,vx,0,650,200,2,b,0,0,0);
		img  = imgLoad.getEnnemi(12);
		
		loco 	= new Locomotive((int)y);
		wagon1 	= new WagonTank((int)y);
		wagon2 	= new WagonArme((int)y);
		wagon3 	= new WagonCirc((int)y);

		if( xx == 0 )
			x = 800;
	}

	
	public void gestionTirs()
	{
		if( loco != null )		
			loco.gestionTirs();

		if( wagon1 != null )		
			wagon1.gestionTirs();

		if( wagon2 != null )		
			wagon2.gestionTirs();

		if( wagon3 != null )		
			wagon3.gestionTirs();
	}	

	
	/**
	 * Recupre la forme de l'ennemi
	 */	
	public Area getArea()
	{
		return new Area( new Rectangle2D.Double(x,y,getWidth(),getHeight()) );
	}	
	
	
	public void collision( Bombe b ){}
	public boolean isPhysique(){return false;}
	

	/**
	 * Recupere les tirs
	 * @return tirs
	 */
	public Vector<TirEnnemi> getTirs()
	{
		if( wagon1 != null )
		{
			tirs.addAll( wagon1.getTirs() );
			wagon1.clearTirs();
		}
		
		if( wagon2 != null )
		{
			tirs.addAll( wagon2.getTirs() );
			wagon2.clearTirs();
		}
		
		if( wagon3 != null )
		{
			tirs.addAll( wagon3.getTirs() );
			wagon3.clearTirs();
		}

		return tirs;
	}	
	

	/**
	 * Collsion entre un ennemi et un tir
	 * @param t
	 */
	public void collision( Tir t)
	{
		if( loco != null )		
			loco.collision(t);

		if( wagon1 != null )		
			wagon1.collision(t);

		if( wagon2 != null )		
			wagon2.collision(t);

		if( wagon3 != null )		
			wagon3.collision(t);
	}	
	

	/**
	 * Collision ennemi / laser
	 * @param i item
	 */	
	public boolean collision( Laser l )
	{
		boolean ok = false;

		if( loco != null && loco.collision(l))		
			ok = true;
		if( wagon1 != null && wagon1.collision(l))	
			ok = true;	
		if( wagon2 != null && wagon2.collision(l))	
			ok = true;			
		if( wagon3 != null && wagon3.collision(l))	
			ok = true;		
		
		return ok;
	}				
	
	
	/**
	 * Rafraichi les coordonnes
	 */
	public void refresh(long temps) 
	{
		// AVANCE LA LOCO
		if( loco != null )
		{
		    if( x > 262 && y > 0)
			{
				if( x > 312 )
				{
					// refresh en fonction de la vtesse
					x += (vitesseX*temps)/1000.0;
				}
				else
				{
					x += (vitesseX*temps*(x-212))/100000.0;
				}
			}

		    loco.setPos( (int)x );
		    
		    // AVANCE LE WAGON 1
			if( wagon1 != null)
			{
				 wagon1.setPos( (int)x+118 );
				 
				 // AVANCE LE WAGON 2
				 if( wagon2 != null )
				 {
					 wagon2.setPos( (int)x+227 ); 
					 
					// AVANCE LE WAGON 3
					 if( wagon3 != null)
					 {
						 wagon3.setPos( (int)x+336 );  
					 }
				 }
			}
		   
		}
		
	    // SUIT LE SCROLLING
		y += (NiveauManager.getNiveauManager().getNiveau().getScrolling() * temps)/1000.0;	

		if( loco != null )
			loco.refresh(temps);		
		if( wagon1 != null )
			wagon1.refresh(temps);
		if( wagon2 != null )
			wagon2.refresh(temps);
		if( wagon3 != null )
			wagon3.refresh(temps);	
		
		// DETRUIRE ENNEMIE
		if( NiveauManager.getNiveauManager().getNiveau().getScrolling() < 100 & 
			(( loco == null && x > 212 + 600 - 100 - 118 ) ||
			( wagon1 == null && x > 212 + 600 - 100 - 118 - 108 ) ||
			( wagon1 == null && wagon2 == null && x > 212 + 600 - 100 - 118 - 108 - 108 ) ||
			( wagon1 == null && wagon2 == null && wagon3 == null )) )
			NiveauManager.getNiveauManager().getNiveau().setScrolling( 150 );

		if( loco != null && loco.isDead() )
		{
			exp.addAll(loco.getExplosions());
			Environnement.getEnvironnement().score += loco.getPoints();
			loco = null;
		}
		if( wagon1 != null && wagon1.isDead() )
		{
			exp.addAll(wagon1.getExplosions());
			Environnement.getEnvironnement().score += wagon1.getPoints();
			wagon1 = null;
		}
		if( wagon2 != null && wagon2.isDead() )
		{
			exp.addAll(wagon2.getExplosions());
			Environnement.getEnvironnement().score += wagon2.getPoints();
			wagon2 = null;
		}
		if( wagon3 != null && wagon3.isDead() )
		{
			exp.addAll(wagon3.getExplosions());
			Environnement.getEnvironnement().score += wagon3.getPoints();
			wagon3 = null;	
		}

	}	
	
	
	/**
	 * Dessine
	 */
	public void shape(Graphics graphics) 
	{
		graphics.drawImage( img.getImage(), 212, (int)y + 3, null );
		
		if( loco != null )		
			loco.shape(graphics);			
		if( wagon1 != null )		
			wagon1.shape(graphics);		
		if( wagon2 != null )		
			wagon2.shape(graphics);		
		if( wagon3 != null )		
			wagon3.shape(graphics);
	}	
	
}