package elements.Explosions;

import java.awt.Graphics;

import controles.ImageManager;
import elements.Dessinable;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class Explosion extends Dessinable
{

	private static final long serialVersionUID = 1L;

	protected ImageManager imgload;
	protected int nbFrames;
	protected int tempsFrame;
	protected int temps;
	

	/**
	 * Constructeur
	 * @param xx x
	 * @param yy y
	 * @param il image loader
	 * @param frames nb de frames
	 * @param temps temps par frame
	 */
	public Explosion( int xx, int yy, int frames, int temps)
	{
		super(xx,yy);
		
		imgload = ImageManager.getImagemanager();
		nbFrames = frames;
		tempsFrame = temps;

		temps = 0;
	}
	
	
	/**
	 * retourne vrai si l'explosion est morte
	 * @return
	 */
	public boolean isDead()
	{
		return temps >= tempsFrame*nbFrames;
	}
	
	
	/**
	 * Rafraichi
	 */
	public void refresh(long t) 
	{
		temps += t;	
	}
	
	
	/**
	 * redessine
	 */	
	public void shape(Graphics graphics) {}	
	
		
	
}
