package elements;

import java.awt.Graphics;
import java.awt.Toolkit;
import java.awt.geom.Area;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Rectangle2D;
import java.io.File;
import javax.swing.ImageIcon;
import sons.Son;
import controles.Clavier;
import controles.Environnement;
import controles.SonManager;
import elements.Ennemis.Ennemi;
import elements.Tirs.Bombe;
import elements.Tirs.Laser;
import elements.Tirs.LaserBombe;
import elements.Tirs.TirEnnemi;
import elements.Tirs.TirJoueur;
import elements.items.*;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class Joueur
{
	// DONNEES
	private static final long serialVersionUID = 1L;
	
	private float x;
	private float y;
	private int vitesseX;
	private int vitesseY;
	private boolean premierDeplacement;
	
	private boolean lightOn;
	
	private long tempsPrecedentTir = 0;	
	private long tempsLaser = 300;
		
	private Environnement env;
	
	// IMAGES
	private ImageIcon ship;
	private ImageIcon shipForward;
	private ImageIcon light;
	
	// SON
	private Son forwardSon;
	private Son expJoueur;	
	
	// CLAVIER
	private Clavier clavier;

	/**
	 * constructeur
	 * @param e
	 */
	public Joueur()
	{
		ship 		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ships/ship.png"		));
		shipForward = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ships/ship_forward.png"));
		light 		= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Ships/mask.png"));
		
		try
		{
			forwardSon = new Son( new File("Sons/forward.wav"));
		}
		catch( Exception ex){}
		
		try
		{
			expJoueur = new Son( new File( "Sons/expJoueur.wav" ) );					
		}
		catch( Exception ex){}

		env 				= Environnement.getEnvironnement();
		env.LVL 			= 0;
		x 					= 482;
		y 					= 770;
		vitesseX 			= 0;
		vitesseY 			= 0;
		clavier 			= Clavier.getClavier();
		premierDeplacement 	= true;
		lightOn 			= false;
		
		tempsLaser = 500;
	}
	
	
	/**
	 * getter
	 * @return
	 */
	public int getX()
	{
		return (int)x;
	}
	
	
	/**
	 * getter
	 * @return
	 */
	public int getY()
	{
		return (int)y;
	}
	
	/**
	 * getter
	 * @return
	 */
	public int getHeight()
	{
		return ship.getIconHeight();
	}
	
	
	/**
	 * getter
	 * @return
	 */
	public int getWidth()
	{
		return ship.getIconWidth();
	}	
	
	
	/**
	 * setter
	 * @param xx
	 */
	public void setX( int xx )
	{
		x = xx;
	}
	
	
	/**
	 * setter
	 * @param yy
	 */
	public void setY( int yy )
	{
		y = yy;
	}
	
	
	/**
	 * setter
	 * @param vx
	 */
	public void setVitesseX( int vx )
	{
		vitesseX = vx;
	}
	
	
	/**
	 * setter
	 * @param vy
	 */
	public void setVitesseY( int vy )
	{
		vitesseY = vy;
	}
	
	public boolean pretLancerBombe()
	{
		return env.tempsAvantProchaineBombe == 0 && env.nombreDeBombes > 0;
	}
	
	public void lancementBombeOk()
	{
		env.tempsAvantProchaineBombe = 2000;
		env.nombreDeBombes -= 1;
	}
	
	public void setLight( boolean on )
	{
		lightOn = on;
	}
	
	/**
	 * Gere les tirs du joueur
	 */
	private void tir()
	{

		SonManager.getSonManager().jouerLaser2();
					
			if( env.LVL == 0)
			{
				for( int i=0;i<5;i++)
				{
					env.tirsJoueur.add( new TirJoueur(getX()+23, getY()+ 20 -(40*i), 0, -1400, 0));
					env.tirsJoueur.add( new TirJoueur(getX()+26, getY()+ 25 -(40*i), 0, -1500,1));
					env.tirsJoueur.add( new TirJoueur(getX()+33, getY()+ 20 -(40*i), 0, -1400,0));				
				}
				
			}
			else if( env.LVL == 1)
			{
				
				for( int i=0;i<5;i++)
				{				
					env.tirsJoueur.add( new TirJoueur(getX()+5, getY()+50 -(40*i), 0, -1600,1));
					env.tirsJoueur.add( new TirJoueur(getX()+28, getY()+20 -(40*i), 0, -1500,0));					
					env.tirsJoueur.add( new TirJoueur(getX()+48, getY()+50 -(40*i), 0, -1600,1));
				}	
				
			}
			else if( env.LVL == 2)
			{
				
				for( int i=0;i<5;i++)
				{					
					env.tirsJoueur.add( new TirJoueur(getX(), getY()+20 -(40*i), 0, -1600,0));						
					env.tirsJoueur.add( new TirJoueur(getX()+5, getY()+25 -(40*i), 0, -1500,1));
					env.tirsJoueur.add( new TirJoueur(getX()+24, getY() -(60*i), 0, -1800,2));							
					env.tirsJoueur.add( new TirJoueur(getX()+47, getY()+25 -(40*i), 0, -1500,1));
					env.tirsJoueur.add( new TirJoueur(getX()+56, getY()+20 -(40*i), 0, -1600,0));	
				}
				
			}
			else if( env.LVL == 3)
			{
				
				for( int i=0;i<5;i++)
				{					
					env.tirsJoueur.add( new TirJoueur(getX()-8, 	getY()+55 -(40*i), -400	, -1400,3));	
					env.tirsJoueur.add( new TirJoueur(getX()+1, 	getY()+25 -(40*i), 0		, -1500,2));
					env.tirsJoueur.add( new TirJoueur(getX()+48, getY()+25 -(40*i), 0		, -1500,2));
					env.tirsJoueur.add( new TirJoueur(getX()+24, getY() 	 -(40*i), 0		, -1800,2));
					env.tirsJoueur.add( new TirJoueur(getX()+55, getY()+55 -(40*i), +400	, -1400,3));	
				}	

				env.tirsJoueur.add( new TirJoueur(getX()+1,  getY()-95,  0, -1500,2));
				env.tirsJoueur.add( new TirJoueur(getX()+48, getY()-95,  0, -1500,2));
				env.tirsJoueur.add( new TirJoueur(getX()+24, getY()-120, 0, -1800,2));

			}
			else if( env.LVL == 4 )
			{
				
				for( int i=0;i<5;i++)
				{					
					env.tirsJoueur.add( new TirJoueur(getX()-8, 	getY()+55 -(40*i), -400	, -1400,3));	
					env.tirsJoueur.add( new TirJoueur(getX()-8, 	getY()+45 -(40*i), -300	, -1400,3));	
					env.tirsJoueur.add( new TirJoueur(getX()-8, 	getY()+35 -(40*i), -200	, -1400,3));					
					env.tirsJoueur.add( new TirJoueur(getX()+1, 	getY()+25 -(40*i), 0		, -1500,2));
					env.tirsJoueur.add( new TirJoueur(getX()+48, getY()+25 -(40*i), 0		, -1500,2));
					env.tirsJoueur.add( new TirJoueur(getX()+24, getY() 	 -(40*i), 0		, -1800,2));
					env.tirsJoueur.add( new TirJoueur(getX()-8, 	getY()+33 -(40*i), -200	, -1400,3));					
					env.tirsJoueur.add( new TirJoueur(getX()+55, getY()+45 -(40*i), +300	, -1400,3));					
					env.tirsJoueur.add( new TirJoueur(getX()+55, getY()+55 -(40*i), +400	, -1400,3));	
				}	

				env.tirsJoueur.add( new TirJoueur(getX()+1,  getY()-95,  0, -1500,2));
				env.tirsJoueur.add( new TirJoueur(getX()+48, getY()-95,  0, -1500,2));
				env.tirsJoueur.add( new TirJoueur(getX()+24, getY()-120, 0, -1800,2));

			}
	}
	
	/**
	 * gestion des tirs
	 */
	private void gereTirs(long temps)
	{
		// Mode si on tappe sur le clavier les tirs ne sont pas limites en temps
		if( ! clavier.isTir())
		{
			tempsLaser = 500;
			tempsPrecedentTir = System.currentTimeMillis() - 600;
		}
		
		if( clavier.isTir2() && pretLancerBombe() && ! env.isPause() && env.vivant)
		{
			clavier.tir2Ok();
			lancementBombeOk();
			SonManager.getSonManager().jouerBombe();
			env.bombes.add( new Bombe( getX() + getWidth()/2, getY() + getHeight()/2) );
		}

		// Limiteur de temps des tirs si reste appuy� -- cr� tir
		if( clavier.isTir() && System.currentTimeMillis() - tempsPrecedentTir > 600 && ! env.isPause() && env.vivant)
		{
			tir();
			tempsPrecedentTir = System.currentTimeMillis();
		}
		else if( clavier.isTir() && ! env.isPause() && env.vivant)
			tempsLaser -= temps;
		
		// Lance le laser
		if( clavier.isTir() && ! env.isPause() && env.vivant && tempsLaser <= 0)
			env.laser = new Laser(getX(),getY());
	}
	
	/**
	 * gestion du laser
	 */
	private void gereLaser(long temps)
	{
		SonManager.getSonManager().jouerLaser();
		
		// SI SIMPLE LASER
		if( env.laser.toString().equals("laser"))
		{
			//et qu'on lache le bouton
			if( ! clavier.isTir() || ! env.vivant )
			{
				env.laser = null;
				tempsLaser = 500;
				SonManager.getSonManager().stopLaser();
				gereTirs(temps);
			}
			else
			{
				// SI BOMBE ON CREER UN LASERBOMBE
				if( clavier.isTir2() && pretLancerBombe() && ! env.isPause() && env.vivant && env.laser.toString().equals("laser"))
				{
					SonManager.getSonManager().jouerLaserBombe();
					clavier.tir2Ok();
					lancementBombeOk();
					env.laser = new LaserBombe(getX(),getY());
				}
			}
		}
		// SI LASERBOMBE
		else
		{
			// On dtruit le laser bombe si le joueur meurt ou si le laser meurt
			if ( ((LaserBombe)env.laser).isDead() || ! env.vivant)
			{
				env.laser = null;
				SonManager.getSonManager().stopLaser();
				SonManager.getSonManager().stopLaserBombe
				();
			}
		}
	}
	
	/**
	 * gestion des tirs et laser
	 */
	public void gereTirsEtLaser(long temps)
	{
		if( env.laser == null)
		{
			gereTirs(temps);
		}
		else
		{
			gereLaser(temps);
		}
	}
	
	

	/**
	 * Collision items / player
	 * @param i item
	 */
	public void collision( Item i )
	{
		if
		(  		env.vivant 	&& 
				i.getX() + i.getWidth()/2					>= x && 
				i.getX() + i.getWidth() - i.getWidth()/2	<= x+ship.getImage().getWidth(null) && 
				i.getY() + i.getHeight()/2					>= y && 
				i.getY() + i.getHeight() - i.getHeight()/2	<= y + ship.getImage().getHeight(null)
		)
			
			
		{
			
			// Si c'est un item de type point on ajoute les points recuperes
			if( i.toString() == "ItemPoint")
				env.addPoints( ((ItemPoint)(i)).getPoint());
			
			// Si c'est un item de type point on ajoute les points recuperes
			if( i.toString() == "ItemTir")
			{
					env.LVL += ((ItemTir)i).getLevel();
					
					// Si on depasse ... bah on defpasse pas
					if( env.LVL > 4 )
						env.LVL = 4;
			}
			
			// Si c'est un item de type point on ajoute les points recuperes
			if( i.toString() == "ItemBombe")
				if( env.nombreDeBombes < 5 )
					env.nombreDeBombes++;
			
			// Detruis l'objet
			i.explose();
		}
	}	

	
	/**
	 * Collision tir / player
	 * @param i item
	 */	
	public void collision( TirEnnemi t )
	{
		Area a1;
		Area a2;
		
		if( Environnement.getEnvironnement().difficulte == 0 )
		{
			a1 = new Area( new Rectangle2D.Double(x+27, y+13,7,13));
			a2 = null;
		}
		else
		{
			a1 = new Area( new Rectangle2D.Double(x+25, y+10,12,60));	
			a2 = new Area( new Ellipse2D.Double( x+11, y+34, 42, 21));
		}
		
		Area t1 = t.getArea();
		Area t2 = t.getArea();
		
		// COLLSIONS
		a1.intersect(t1);
		if( a2 != null )
			a2.intersect(t2);
		
		if( ! ( a1.isEmpty() && ( a2 == null || a2.isEmpty()) ) && env.vivant && env.invincible <= 0)
		{
			env.vivant = false;
			env.tempsMort = 0;
			
			if( expJoueur != null )
				expJoueur.jouer();
			
			t.explose();
			env.perdreVie();
			env.LVL = 0;			
		}
	}
	
	
	/**
	 * Collision ennemi / player
	 * @param i item
	 */	
	public void collision( Ennemi e )
	{
		Area a1;
		Area a2;
		
		if( Environnement.getEnvironnement().difficulte == 0 )
		{
			a1 = new Area( new Rectangle2D.Double(x+27, y+13,7,13));
			a2 = null;
		}
		else
		{
			a1 = new Area( new Rectangle2D.Double(x+25, y+10,12,60));	
			a2 = new Area( new Ellipse2D.Double( x+11, y+34, 42, 21));
		}
		
		Area t1 = e.getArea();
		Area t2 = e.getArea();
		
		// COLLSIONS
		a1.intersect(t1);
		if( a2 != null )
			a2.intersect(t2);
		
		if( ! ( a1.isEmpty() && ( a2 == null || a2.isEmpty()) ) && env.vivant && env.invincible <= 0 && e.isPhysique() )
		{
			env.vivant = false;
			env.tempsMort = 0;
			
			if( expJoueur != null)
				expJoueur.jouer();
			
			e.setATueLeJoueur(true);
			env.perdreVie();
			env.LVL = 0;
		}
	}	
	
	
	/**
	 * Refresh des coords
	 * @param temps
	 */
	public void refresh(long temps) 
	{
		float facteur = 1;
		
		if( tempsLaser <= 0 )
			facteur = 0.80f;
		
		if( ! env.isPause() && env.vivant)
		{
			// SI on joue, on refresh en fonction des contoles
			if( env.isPlay())
			{
				if( vitesseX ==0 && vitesseY == 0 )
				{
					premierDeplacement = true;
				}
				else
				{
					premierDeplacement = false;
					vitesseX = 0;
					vitesseY = 0;
				}
				
				if( premierDeplacement )
				{
					if (clavier.isGauche())
					{
						vitesseX = -100;
					}
			
					if (clavier.isDroite()) 
					{
						vitesseX = 100;
					}
					
					if (clavier.isHaut()) 
					{
						vitesseY = -150;
					}
		
					if (clavier.isBas())
					{
						vitesseY = 150;
					}
				}
				else
				{
					if (clavier.isGauche())
					{
						vitesseX = -280;
					}
			
					if (clavier.isDroite()) 
					{
						vitesseX = 280;
					}
					
					if (clavier.isHaut()) 
					{
						vitesseY = -330;
					}
		
					if (clavier.isBas())
					{
						vitesseY = 330;
					}					
				}
				
				if( vitesseX !=0 && vitesseY !=0)
				{
					vitesseX = vitesseX * 90 / 100;
					vitesseY = vitesseY * 90 / 100;
				}
			}
			
			// refresh en fonction de la vtesse
			x += (vitesseX*temps)/1000.0 * facteur;
			y += (vitesseY*temps)/1000.0 * facteur;	
			
			// Si on joue, met des contraintes.
			if( env.isPlay() )
			{
				if(x > 762)
					x=762;
				
				if(x < 212)
					x=212;
					
				if(y > 694)
					y = 693;
					
				if(y < 0)
					y = 0;
			}
			
			// gestion des sons
			if( forwardSon != null)
				if( vitesseY < 0 && y>0 && ! forwardSon.estEntrainDeJouer()){
					forwardSon.jouer();
				}else if( ( vitesseY >= 0 || y==0 ) && forwardSon.estEntrainDeJouer() ){
					forwardSon.stop();}
		}
		else
			if( forwardSon != null )
			forwardSon.stop();			
	}	
	
	
	/**
	 * Redessine le vaisseau
	 * @param graphics
	 */
	public void shape(Graphics graphics) 
	{
		if( env.vivant && env.blink < 150)
		{
			if( lightOn )
				graphics.drawImage( light.getImage() , (int)x - 36, (int)y - 24, null  );	
			
			if( vitesseY < 0 && y>0 )
				graphics.drawImage( shipForward.getImage() , (int)x, (int)y, null  );			
			else
				graphics.drawImage( ship.getImage(), (int)x, (int)y, null  );
		}
	}	

}
