package elements.Tirs;

import java.awt.AlphaComposite;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.Area;
import java.awt.geom.Ellipse2D;

import controles.ImageManager;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class Bombe extends Tir
{
	ImageManager imgLoad;
	float taille;
	float transp;
	
	/**
	 * Constructeur
	 * @param xx x
	 * @param yy y
	 * @param vx Vitesse X
	 * @param vy Vitesse Y
	 * @param l niveau du tir
	 * @param il image loader
	 */
	public Bombe(int xx,int yy)
	{
		super(xx,yy,0,0,1500);
		
		imgLoad = ImageManager.getImagemanager();

		img 	= imgLoad.getBombe();
		taille 	= 0.1f;
		transp 	= 1;
	}
	
	/**
	 * rafraichi posotions
	 */
	public void refresh(long temps) 
	{
		taille += (3*temps)/1000.0;
		
		if( taille > 2 && transp > 0 )
			transp -= (1.2*temps)/1000.0;

		if( transp < 0)
			transp = 0;
	}	
	
	
	/**
	 * retourne vrai si la taille est inferieur a la taille max
	 */
	public boolean isVisible()
	{
		return taille < 4;
	}

	
	/**
	 * Recupre la forme de l'ennemi
	 */	
	public Area getArea()
	{
		return new Area( new Ellipse2D.Double(x - (int)(115*taille) ,y - (int)(115*taille) ,230*taille,230*taille) );
	}
	
	public Area getAreaInterne()
	{
		return new Area( new Ellipse2D.Double(x - (int)(60*taille) ,y - (int)(60*taille) ,120*taille,120*taille) );
	}
	
	
	/**
	 * redessine 
	 */
	public void shape(Graphics graphics) 
	{
		((Graphics2D)graphics).setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, transp ));
		graphics.drawImage( img.getImage() , (int)x - (int)(150*taille) , (int)y - (int)(150*taille), (int)(300*taille) , (int)(300*taille) ,null);
		((Graphics2D)graphics).setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 1.0f ));	
	}		
}
