package elements.Tirs;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.TexturePaint;
import java.awt.geom.Area;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;

public class LaserBombe extends Laser
{
	private long tempsBombe;
	
	/**
	 * Construction d'une bombe laser
	 * @param xx position en X
	 * @param yy position en Y
	 */
	public LaserBombe(int xx,int yy)
	{
		super(xx,yy);
		tempsBombe = 3000;
	}
	
	
	/**
	 * MaxY est le haut de l'ecran
	 */
	public void setMaxY( int my ){}
	
	
	/**
	 * getForce
	 */
	public int getForce()
	{
		return (int)((200 * tempsEntreDeuxFrames)/400.0);
	}
	
	/**
	 * recupre le temps d'imunit au laser
	 * @return
	 */
	public int getTempsImunise()
	{
		return 0;
	}
	
	
	/**
	 * Taille du laser
	 */
	public int getWidth()
	{
		if( tempsBombe > 2500 )
			return (int)(  ( - tempsBombe + 3000)/500f*241);
		else
			return 241;
	}
	
	
	/**
	 * Taille du laser
	 */
	public int getHeight()
	{
		return (int)y - maxY;
	}
	
	
	/**
	 * Vrai si le laser est mort
	 * @return Vrai si le laser est mort
	 */
	public boolean isDead()
	{
		return tempsBombe <= 0;
	}
	
	
	/**
	 * refresh
	 */
	public void refresh(long temps, int xx, int yy) 
	{
		super.refresh(temps,xx,yy);
		tempsBombe -= temps;
	}
	
	
	/**
	 * redessine 
	 */
	public void shape(Graphics graphics) 
	{
		// CREATION DU BUFFER
        BufferedImage bufferedImage = new BufferedImage( 242 , 248, BufferedImage.TYPE_INT_ARGB );
        Graphics g 					= bufferedImage.createGraphics();
        g.drawImage( imgLoad.getJoueurLaser(5).getImage(), 0, 0, null );
        g.dispose();
        
        // CAST
		Graphics2D g2d = (Graphics2D)graphics;
		
		// TEXTURE
		g2d.setPaint(new TexturePaint(bufferedImage, new Rectangle((int)x + 30 - getWidth()/2	, -decalage ,getWidth(),248)));
	
		// CALCUL DES ZONES ARRONDIES
		Area cercleBas;
		Area containerBas;
	
		cercleBas 		= new Area( new Ellipse2D.Double  	( (int)x - getWidth()/2 + 30 , (int)y - getWidth()*2 	, getWidth(), getWidth()*2 ) );
		containerBas 	= new Area( new Rectangle2D.Double	( (int)x - getWidth()/2 + 30 , (int)y - getWidth()   	, getWidth(), getWidth()*2 ) );	
		cercleBas.intersect(containerBas);
		g2d.fill( cercleBas );

		g2d.fillRect( (int)x - getWidth()/2 + 30 , (int)y - getHeight()				, getWidth(), getHeight() - getWidth() );	
	}	
	
	
	/**
	 * permet de savoir si c'est un laser simple ou un laserBombe
	 */
	public String toString()
	{
		return "bombe";
	}

}
