package elements.Tirs;

import java.awt.Graphics;
import elements.Dessinable;


/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class Tir extends Dessinable  implements Comparable<Tir>
{
	private static final long serialVersionUID = 1L;

	protected boolean aTueLeJoueur;
	protected int vitesseX;
	protected int vitesseY;
	protected int force;
	
	// interpolation entre deux frames
	protected int yPrecedent;
	
	protected int visible;
	

	/**
	 * Constructeur
	 * @param xx x
	 * @param yy y
	 * @param vx vitesse x
	 * @param vy vitesse y
	 * @param f force
	 */
	public Tir(int xx, int yy, int vx, int vy, int f)
	{
		super(xx,yy);
		
		yPrecedent = yy;
		vitesseX = vx;
		vitesseY = vy;
		visible = 1;
		force = f;
		aTueLeJoueur = false;
		
	}

	/**
	 * getter
	 */	
	public int getYPrededent()
	{
		return (int)y;
	}	
	

	/**
	 * getter
	 */	
	public int getForce()
	{
		return force;
	}
	
	
	/**
	 * getter
	 */	
	public int getWidth()
	{
		return img.getImage().getWidth(null);
	}
	
	
	/**
	 * getter
	 */	
	public int getHeight()
	{
		return img.getImage().getHeight(null);
	}		
	

	/**
	 * Vrai si l'ennemi a tu le joueur
	 * @return l'ennemi a tu le joueur
	 */
	public boolean getATueLeJoueur()
	{
		return aTueLeJoueur;
	}
	
	
	/**
	 * Choisi si l'ennemi a tue le joueur ( a mettre a faux aprs traitement )
	 * @param b l'ennemi a tu le joueur
	 */
	public void setATueLeJoueur( boolean b)
	{
		aTueLeJoueur = b;
	}	
	
	
	/**
	 * getter
	 */	
	public boolean isVisible()
	{
		return visible == 1;
	}
	
	
	/**
	 * Detuit le tir
	 */
	public void explose()
	{
		visible = 0;
		force = 0;
		aTueLeJoueur = true;
	}	
	
	/**
	 * Collision ennemi / player
	 * @param i item
	 */	
	public void collision( Bombe b )
	{
	}		

	/**
	 * rafraichi posotions
	 */
	public void refresh(long temps) 
	{
		x += (vitesseX*temps)/1000.0;
		y += (vitesseY*temps)/1000.0;
	}	
	
	
	/**
	 * redessine
	 */
	public void shape(Graphics graphics) 
	{
	}

	
	/**
	 * compare pour classer
	 */
	public int compareTo(Tir t) 
	{
		return new Integer( (int)y ).compareTo( new Integer( (int)t.y ));
	}	
}
