package elements.Tirs;

import java.awt.Graphics;
import java.awt.geom.Area;
import java.awt.geom.Ellipse2D;

import controles.ImageManager;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class TirEnnemi  extends Tir
{
	private static final long serialVersionUID = 1L;
	
	protected ImageManager imgLoad;

	/**
	 * Constructeur
	 * @param xx x
	 * @param yy y
	 * @param vx vitesse X
	 * @param vy vitresse Y
	 * @param il image loader
	 */
	public TirEnnemi(int xx,int yy, int vx, int vy)
	{
		super(xx,yy,vx,vy,0);
		imgLoad = ImageManager.getImagemanager();
		
		img = imgLoad.getEnnemiTir(0);
	}
	
	
	/**
	 * Recupre la forme de l'ennemi
	 */	
	public Area getArea()
	{
		return new Area( new Ellipse2D.Double(x+5,y+5,getWidth()-5,getHeight()-5) );
	}

	/**
	 * Collision ennemi / player
	 * @param i item
	 */	
	public void collision( Bombe b )
	{
		Area a1 = getArea();
			
		Area t1 = b.getArea();
		Area t2 = b.getAreaInterne();
		
		t1.intersect(a1);
		t2.intersect(a1);

		if(  ! t1.isEmpty() && t2.isEmpty() )
			visible = 0;
		
	}
	
	/**
	 * Collision tir / laser
	 * @param i item
	 */	
	public void collision( Laser l )
	{
		Area a1 = getArea();
		
		Area t1 = l.getArea();
		
		t1.intersect(a1);

		if( ! t1.isEmpty() )
			visible = 0;
	}	
	
	/**
	 * redessine
	 */
	public void shape(Graphics graphics) 
	{
		graphics.drawImage( img.getImage(), (int)x, (int)y, null  );
	}		
}
