package elements.items;

import java.awt.Graphics;
import controles.ImageManager;
import elements.Dessinable;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class Item extends Dessinable
{
	protected int vitesseY;
	protected int yPrecedent;
	protected int temps;
	protected ImageManager imgLoad;
	
	protected boolean visible;

	
	/**
	 * Constructeur
	 * @param xx x
	 * @param yy y
	 * @param vy Vitesse Y
	 */
	public Item( int xx, int yy, int vy)
	{
		super(xx,yy);
		imgLoad = ImageManager.getImagemanager();
		vitesseY = vy;
		visible = true;
		
		if( vitesseY == 0 )
			vitesseY = 200;
		
		if( vitesseY > 300)
			vitesseY = 300;
	}
	
	
	/**
	 * Tue l'item
	 */
	public void explose()
	{
		visible = false;
	}
	
	
	/**
	 * L'objet est il mort ?
	 * @return vrai si l'objet est mort
	 */
	public boolean isDead()
	{
		return ! visible;
	}
	
	
	/**
	 * Recup le y de la frame d'avant
	 * @return YPrededent
	 */
	public int getYPrededent()
	{
		return yPrecedent;
	}
	
	
	/**
	 * Refresh ( vide )
	 */
	public void refresh(long t) 
	{
	}
	
	
	/**
	 * Shape ( vide )
	 */
	public void shape(Graphics graphics) 
	{
	}	
	
	
	/**
	 * Statut de l'item ( Item )
	 */
	public String toString()
	{
		return "Item";
	}	
	
}
