package elements.items;

import java.awt.Graphics;

import controles.NiveauManager;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class ItemBombe extends Item
{

	/**
	 * COnstructeur d'une bombe
	 * @param xx x
	 * @param yy y
	 * @param vy Vitesse Y
	 */
	public ItemBombe( int xx, int yy, int vy)
	{
		super(xx,yy,vy);
		
		if( vy == 0 )
			vitesseY = 150;
	}
	
	
	/**
	 * Recup la taille de l'image
	 */
	public int getWidth()
	{
		return imgLoad.getItemPoint(0).getImage().getWidth(null);
	}

	
	/**
	 * Recup la taille de l'image
	 */	
	public int getHeight()
	{
		return imgLoad.getItemPoint(0).getImage().getHeight(null);
	}		
	
	
	/**
	 * Refresh
	 */
	public void refresh(long t) 
	{
		yPrecedent = (int)y;
		
		//MAJ POSITIONS
		if( NiveauManager.getNiveauManager().getNiveau().getScrolling() > 10 )
		{
			y += (NiveauManager.getNiveauManager().getNiveau().getScrolling() * t)/1000.0;
			y += vitesseY * t /10000.0;
		}
		else
		{
			y += vitesseY * t /3000.0;			
		}
		
		temps = ( temps + (int)t )%600;
	}	
	
	
	/**
	 * SHape
	 */
	public void shape(Graphics graphics) 
	{
		graphics.drawImage( imgLoad.getItemBombe(temps/100).getImage(), (int)x, (int)y, null  );
	}		
	
	
	/**
	 * Statut objet
	 */
	public String toString()
	{
		return "ItemBombe";
	}
	
}