package launcher;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Properties;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import controles.Clavier;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class LauncherKeys extends KeyAdapter
{
	private static final long serialVersionUID = 1L;
	private String title;
	private JPanel panel;
	
	private boolean 	 waitKey;
	private int 		 toucheEnAttente;
	private int[] 		 numTouches;	
	private Clavier 	 clavier;
	private JTextField[] touche;
	private JButton[] 	 editTouche;
	private JLabel 		 etat;		

	public LauncherKeys()
	{
		title 		= "Keyboard";
		panel 		= new JPanel();
		
		clavier 	= Clavier.getClavier();
		numTouches 	= clavier.getListeTouches();
		etat 		= new JLabel("");
		touche 		= new JTextField[7];
		editTouche 	= new JButton[7];
		
		for(int i=0;i<7;i++)
		{
			touche[i] = new JTextField( KeyEvent.getKeyText( numTouches[i] ) );
			touche[i].setEditable(false);
			
			editTouche[i] = new JButton("Modify");
			
			editTouche[i].addActionListener( new ActionListener()
			{
			    public void actionPerformed (ActionEvent evt)
			    {
			    	int index=0;
			    	
			    	for( int i=0; i<7 ; i++ )
			    	{
			    		touche[i].setText( KeyEvent.getKeyText( numTouches[i] ) );
			    		
			    		if( evt.getSource() == editTouche[i] )
			    			index = i;
			    	}
			    	
			    	touche[index].setText("Press a Key");
			    	touche[index].requestFocus();
			    	toucheEnAttente = index;
			    	waitKey = true;
			    	etat.setText("");
				}
			});
			
			touche[i].addKeyListener( this );
		}
		
		panel.setLayout( new BorderLayout() );
		
		GridLayout gl = new GridLayout(0,3);
		JPanel contain = new JPanel();
		contain.setLayout(gl);
		
		contain.add( new JLabel(" UP       "));
		contain.add( touche[0] 				);
		contain.add( editTouche[0] 			);
		
		contain.add( new JLabel(" DOWN     "));
		contain.add( touche[1] 				);	
		contain.add( editTouche[1] 			);	
		
		contain.add( new JLabel(" LEFT     "));
		contain.add( touche[2] 				);	
		contain.add( editTouche[2] 			);
		
		contain.add( new JLabel(" RIGHT    "));
		contain.add( touche[3] 				);	
		contain.add( editTouche[3] 			);
		
		contain.add( new JLabel(" SHOOT    "));
		contain.add( touche[4] 				);	
		contain.add( editTouche[4] 			);	
		
		contain.add( new JLabel(" BOMB     "));
		contain.add( touche[5] 				);	
		contain.add( editTouche[5] 			);	
		
		contain.add( new JLabel(" PAUSE    "));
		contain.add( touche[6] 				);	
		contain.add( editTouche[6] 			);	

		panel.add( contain, BorderLayout.NORTH );
		panel.add( etat, BorderLayout.CENTER );
	}
	

	/**
	 * recupre les touches
	 */
	public void keyReleased(KeyEvent keyEvent) 
	{
		if( waitKey )
		{
		
			boolean ok = true;
		
			for(int i=0;i<7;i++)
			{
				if( ( numTouches[i] == keyEvent.getKeyCode() || keyEvent.getKeyCode() == 27 || keyEvent.getKeyCode() == 10 ) && i != toucheEnAttente)
					ok=false;
			}
	
			if( ok )
			{
				numTouches[toucheEnAttente] = keyEvent.getKeyCode();
			}
			else
			{
				etat.setText("Error, this Key is already assigned");
			}
			
			touche[toucheEnAttente].setText( KeyEvent.getKeyText( numTouches[toucheEnAttente] ) );	
		
			waitKey = false;
		}
		else
			etat.setText("");
	}
	

	/**
	 * Ecrit dans le fichier clavier.dat
	 */
	public void writeKeys()
	{
		Properties lecteur = new Properties();
		FileInputStream fichier;
		FileOutputStream fichier2;
		try
		{
			fichier = new FileInputStream("Data/clavier.dat");
			lecteur.load(fichier);
			fichier.close();
			
			lecteur.setProperty("left"	,Integer.toString( numTouches[2] ) );	
			lecteur.setProperty("right"	,Integer.toString( numTouches[3] ) );	
			lecteur.setProperty("up"	,Integer.toString( numTouches[0] ) );	
			lecteur.setProperty("down"	,Integer.toString( numTouches[1] ) );	
			lecteur.setProperty("shoot"	,Integer.toString( numTouches[4] ) );	
			lecteur.setProperty("bomb"	,Integer.toString( numTouches[5] ) );	
			lecteur.setProperty("pause"	,Integer.toString( numTouches[6] ) );	
			
			fichier2 = new FileOutputStream("Data/clavier.dat");
			lecteur.store( fichier2 , null);
			fichier2.close();
			
		}
		catch( Exception e){}
	}		
	

	
		
	
	public JPanel getJPanel()
	{
		return panel;
	}
	
	public String getTitle()
	{
		return title;
	}		
}
