package launcher;

import java.awt.GridLayout;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Properties;

import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class LauncherOptions extends JPanel
{
	private static final long serialVersionUID = 1L;
	private String title;

	
	private JCheckBox antiAliasing;
	private JCheckBox effects;
	private JCheckBox fullScreen;
	private JComboBox continues;
	private JComboBox difficulte;
	
	private int isAntiAliasing;
	private int isEffects;
	private int isFullScreen;
	private int nbContinues;	
	private int nbDifficulte;
	
	public LauncherOptions()
	{
		title = "Options";

	readOptions();
		
		GridLayout gl = new GridLayout(0,2);
		JPanel contain = new JPanel();
		
		// OPTIONS
		antiAliasing 	= new JCheckBox();
		effects			= new JCheckBox();
		fullScreen		= new JCheckBox();		
		
		// CONTINUES
		continues 		= new JComboBox();
		continues.addItem( "1" );
		continues.addItem( "3" );
		continues.addItem( "5" );
		continues.addItem( "9" );
		
		// CONTINUES
		difficulte 		= new JComboBox();
		difficulte.addItem( "Normal" );
		difficulte.addItem( "Hard" );	
		
		// SELECTION
		if( isAntiAliasing == 1 )
			antiAliasing.setSelected(true);
		
		if( isEffects == 1 )
			effects.setSelected(true);
		
		if( isFullScreen == 1 )
			fullScreen.setSelected(true);
		
		for( int i=0; i<continues.getItemCount(); i++ )
			if ( continues.getItemAt(i).equals( Integer.toString( nbContinues ) ) )
				continues.setSelectedIndex(i);
		
		difficulte.setSelectedIndex(nbDifficulte);

		contain.setLayout(gl);
	
		// COMP
		contain.add( new JLabel("Continues       "));
		contain.add( continues );		
		
		contain.add( new JLabel("Difficulty       "));
		contain.add( difficulte );	
		
		contain.add( new JLabel("Anti-Aliasing   "));
		contain.add( antiAliasing );		
		
		contain.add( new JLabel("Visual Effetcs  "));
		contain.add( effects );		
		
		contain.add( new JLabel("FullScreen      "));
		contain.add( fullScreen );
		
		add( contain );		
	}
	
	/** 
	 * Lis les options
	 */
	public void readOptions()
	{
		Properties lecteur = new Properties();
		FileInputStream fichier;
		
		try
		{
			fichier = new FileInputStream("Data/options.dat");
			lecteur.load(fichier);
			fichier.close();

			isAntiAliasing 	= Integer.parseInt( lecteur.getProperty("antiAliasing") );	
			isEffects 		= Integer.parseInt( lecteur.getProperty("effects") );	
			isFullScreen 	= Integer.parseInt( lecteur.getProperty("fullScreen") );	
			nbContinues 	= Integer.parseInt( lecteur.getProperty("nombreDeContinus") );	
			nbDifficulte	= Integer.parseInt( lecteur.getProperty("difficulte") );	
		}
		catch( Exception e)
		{
			isAntiAliasing 	= 1;	
			isEffects 		= 1;	
			isFullScreen 	= 1;	
			nbContinues 	= 3;	
			nbDifficulte	= 1;
		}
	}

	/**
	 * Ecrit dans le fichier options.dat
	 */
	public void writeOptions()
	{
		// ON RECUP LES OPTIONS
		nbContinues = Integer.parseInt( (String)continues.getSelectedItem() );
		
		if( fullScreen.isSelected() )
			isFullScreen = 1;
		else
			isFullScreen = 0;
		
		if( antiAliasing.isSelected() )
			isAntiAliasing = 1;
		else
			isAntiAliasing = 0;
		
		if( effects.isSelected() )
			isEffects = 1;
		else
			isEffects = 0;
		
		nbDifficulte = difficulte.getSelectedIndex();

		// ET ON LES SAUVEGARDE
		
		Properties lecteur = new Properties();
		FileInputStream fichier;
		FileOutputStream fichier2;
		try
		{
			fichier = new FileInputStream("Data/options.dat");
			lecteur.load(fichier);
			fichier.close();
			
			lecteur.setProperty("nombreDeContinus"	,Integer.toString( nbContinues ) );	
			lecteur.setProperty("difficulte"		,Integer.toString( nbDifficulte ) );	
			lecteur.setProperty("fullScreen"		,Integer.toString( isFullScreen 	) );	
			lecteur.setProperty("antiAliasing"		,Integer.toString( isAntiAliasing 	) );	
			lecteur.setProperty("effects"			,Integer.toString( isEffects 		) );	
					
			fichier2 = new FileOutputStream("Data/options.dat");
			lecteur.store( fichier2 , null);
			fichier2.close();
			
		}
		catch( Exception e){}
	}	
	
	public String getTitle()
	{
		return title;
	}
	
}
