package menus;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.RenderingHints;

import javax.swing.ImageIcon;

import controles.Clavier;
import controles.SonManager;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class Menu
{
	private static final long serialVersionUID = 1L;

	protected ImageIcon[] menu;
	protected ImageIcon[] menuChoix;
	
	protected String typeDeMenu;	
	protected int choix;
	
	protected ImageIcon fond;
	
	// dur�es
	protected long boucle;
	protected long dernierDeplacement = 0;
	
	protected int ecart;
	
	
	// clavier
	Clavier clavier;	
	
	public Menu()
	{
		clavier = Clavier.getClavier();
		ecart = 35;
	}
	
	public void refresh(long t) 
	{
		// dur�e
		boucle = System.currentTimeMillis();
		
		// affichage dans la fen�tre

		
		// Si ni haut ni bas n'est press�, on remet le compteur a zero
		if( ! clavier.isHaut() && ! clavier.isBas() && ! clavier.isGauche() && ! clavier.isDroite())
			dernierDeplacement = boucle - 300;			

		// d�placement dans le menu
		if ( boucle - dernierDeplacement > 200 ) 
		{
			// Si haut
			if (clavier.isHaut()) 
			{
				choix = choix-1;
				
				if( choix < 0)
					choix = menu.length - 1;
				
				dernierDeplacement = boucle;
				
				SonManager.getSonManager().jouerBeep();		
			}
			// Si Bas
			else if (clavier.isBas()) 
			{
				choix = (choix+1)%menu.length;
				dernierDeplacement = boucle;

				SonManager.getSonManager().jouerBeep();		
			}	
		}
	}		
	
	public void shape(Graphics2D graphics2D) 
	{
		graphics2D.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_OFF);
		graphics2D.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_OFF);
		graphics2D.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_SPEED);
		graphics2D.setRenderingHint(RenderingHints.KEY_COLOR_RENDERING, RenderingHints.VALUE_COLOR_RENDER_SPEED);
		graphics2D.setRenderingHint(RenderingHints.KEY_FRACTIONALMETRICS, RenderingHints.VALUE_FRACTIONALMETRICS_OFF);
		graphics2D.setRenderingHint(RenderingHints.KEY_DITHERING, RenderingHints.VALUE_DITHER_DISABLE);	
		
		graphics2D.setColor(Color.white);
		graphics2D.fillRect(0, 0, 800, 600);
		graphics2D.drawImage( fond.getImage(),0,0, null );
		
		// MENU
		for (int i = 0 ; i < menu.length ; i++) 
		{
			if (i == choix) 
				graphics2D.drawImage(menuChoix[i].getImage(), 760, 165+i*ecart, null);
			else 
				graphics2D.drawImage(menu[i].getImage(), 760, 165+i*ecart, null);
		}
	}	

	/**
	 * Renvoie le choix
	 * @return le choix
	 */
	public int getChoix() 
	{
		return choix;
	}
	
	public String getTypeDeMenu()
	{
		return typeDeMenu;
	}
	
}
