package menus;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Properties;

import controles.Clavier;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class MenuAskScore
{
	private char[] nom;
	private int score;
	
	private String[] scores;
	private String[] nomsScores;
	
	private int choix;
	private long boucle;
	private long dernierDeplacement = 0;
	
	private boolean ok;
	
	private Clavier clavier;
	
	public MenuAskScore( int sc)
	{
		scores 		= new String[10];
		nomsScores	= new String[10];
		nom 		= new char[3];
		nom[0] 		= nom[1] = nom[2] = 'A';		
		
		ok = false;
		score = sc;		
 		choix = 0;
		clavier = Clavier.getClavier();
		
		chargerScore();
	}
	
	
	public void chargerScore()
	{
		Properties lecteur = new Properties();
		FileInputStream fichier;
		
		try
		{
			fichier = new FileInputStream("Data/scores.dat");
			lecteur.load(fichier);
			fichier.close();
			
			for( int i=0; i<scores.length; i++)
				scores[i] = lecteur.getProperty("score"+(i+1));
			
			for( int i=0; i<scores.length; i++)
				nomsScores[i] = lecteur.getProperty("init"+(i+1));			
		}
		catch( Exception e)
		{
			for( int i=0; i<scores.length; i++)
				scores[i] = lecteur.getProperty("0000000000");
			
			for( int i=0; i<scores.length; i++)
				nomsScores[i] = lecteur.getProperty("AAA");	
		}	
		
		// REGARDE SI NOTRE SCORE EST MIEUX QUE CEUX DANS LA LISTE
		
		if( score <= Integer.parseInt(scores[9]) )
			ok = true;
	}
	
	public void enregistrerScore()
	{
		Properties lecteur = new Properties();
		FileInputStream fichier;
		FileOutputStream fichier2;
		Boolean scoreMis = false;
		
		try
		{
			fichier = new FileInputStream("Data/scores.dat");
			lecteur.load(fichier);
			fichier.close();
			
			
			
			// SCORE EN STRING
			String scoreString = Integer.toString(score);
			for( int i=scoreString.length(); i<10;i++)
				scoreString = "0"+scoreString;			
			
			
			for( int i=0,j=0; i<scores.length; i++)
			{
				if( Integer.parseInt( scores[j] ) > score || scoreMis)
				{
					lecteur.setProperty("score"+(i+1), scores[j] );	
					lecteur.setProperty("init"+(i+1), nomsScores[j] );						
					j++;
				}
				else
				{
					lecteur.setProperty("score"+(i+1), scoreString );
					lecteur.setProperty("init"+(i+1), ""+nom[0]+nom[1]+nom[2] );						
					scoreMis = true;
				}

			}
			
			fichier2 = new FileOutputStream("Data/scores.dat");
			lecteur.store( fichier2 , null);
			fichier2.close();
			
		}
		catch( Exception e){}		
	}
	
	public void refresh( long t )
	{
		// dure
		boucle = System.currentTimeMillis();
		
		// affichage dans la fentre

		
		// Si ni haut ni bas n'est press, on remet le compteur a zero
		if( ! clavier.isHaut() && ! clavier.isBas() && ! clavier.isGauche() && ! clavier.isDroite())
			dernierDeplacement = boucle - 300;			

		// dplacement dans le menu
		if ( boucle - dernierDeplacement > 200 ) 
		{
			// Si haut
			if (clavier.isHaut()) 
			{
				nom[choix]--;
				
				if( nom[choix] < 'A')
					nom[choix] = 'Z';
				
				dernierDeplacement = boucle;
			}
			// Si Bas
			else if (clavier.isBas()) 
			{
				nom[choix]++;

				if( nom[choix] > 'Z')
					nom[choix] = 'A';
				
				dernierDeplacement = boucle;				
			}	
		}	
		
		if( clavier.isEntrer() )
		{
			if ( choix < 2 )
			{
				clavier.entrerOk();
				choix++;
			}
			else
			{
				ok = true;
				clavier.entrerOk();
				enregistrerScore();
			}
		}
	}
	
	public boolean isOk()
	{
		return ok;
	}
	
	public void shape( Graphics g )
	{
		g.setColor( new Color( 0,0,0,80) );
		g.fillRect(212, 0, 600, 768);
		g.setColor( Color.WHITE );	
		g.setFont(new Font(Font.MONOSPACED, Font.BOLD, 20));			
		g.drawString( "Enter Your Name" , 410, 300);
		for( int i=0; i<=choix; i++)
			g.drawString( Character.toString( nom[i] ), 470 + 20*i, 320);
	}
	
}
