package menus;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.Toolkit;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Properties;
import java.awt.event.KeyEvent;
import javax.swing.ImageIcon;
import controles.SonManager;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class MenuClavier extends Menu
{
	private static final long serialVersionUID = 1L;

	private boolean 	waitKey;
	private boolean 	touchesModifies;
	private boolean 	toucheDejaPrise;
	private String[] 	touches;
	private int[] 		numTouches;


	/**
	 * constructeur
	 */
	public MenuClavier()
	{
		String path = this.getClass().getResource(".").getPath().replaceAll("%20", " ");
		path 		+= "../../";		
		fond = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/options.png"));				
		touches = new String[] {"UP","DOWN","LEFT","RIGHT","FIRE","BOMB","PAUSE","    APPLY CHANGES","         BACK"};
		numTouches = clavier.getListeTouches();
	}
	
	/**
	 * Ecrit dans le fichier clavier.dat
	 */
	public void writeOptions()
	{
		Properties lecteur = new Properties();
		FileInputStream fichier;
		FileOutputStream fichier2;
		try
		{
			fichier = new FileInputStream("Data/clavier.dat");
			lecteur.load(fichier);
			fichier.close();
			
			lecteur.setProperty("left"	,Integer.toString( numTouches[2] ) );	
			lecteur.setProperty("right"	,Integer.toString( numTouches[3] ) );	
			lecteur.setProperty("up"	,Integer.toString( numTouches[0] ) );	
			lecteur.setProperty("down"	,Integer.toString( numTouches[1] ) );	
			lecteur.setProperty("shoot"	,Integer.toString( numTouches[4] ) );	
			lecteur.setProperty("bomb"	,Integer.toString( numTouches[5] ) );	
			lecteur.setProperty("pause"	,Integer.toString( numTouches[6] ) );	
			
			fichier2 = new FileOutputStream("Data/clavier.dat");
			lecteur.store( fichier2 , null);
			fichier2.close();
			
		}
		catch( Exception e){}
	}			
	
	
	/**
	 * refresh
	 */
	public void refresh(long t) 
	{
		// dur�e
		boucle = System.currentTimeMillis();
		
		// affichage dans la fen�tre

		
		// Si ni haut ni bas n'est press�, on remet le compteur a zero
		if( ! clavier.isHaut() && ! clavier.isBas() && ! clavier.isGauche() && ! clavier.isDroite())
			dernierDeplacement = boucle - 300;			

		// d�placement dans le menu
		if ( boucle - dernierDeplacement > 200 ) 
		{
			// SI ON EST PAS EN MODE COUTE
			if( ! waitKey )
			{
				// Si haut
				if (clavier.isHaut()) 
				{
					choix = choix-1;
					
					if( choix < 0)
						choix = touches.length - 1;
					
					dernierDeplacement = boucle;
					
					touchesModifies = false;
					toucheDejaPrise = false;						
					
					SonManager.getSonManager().jouerBeep();		
				}
				// Si Bas
				else if (clavier.isBas()) 
				{
					choix = (choix+1)%touches.length;
					dernierDeplacement = boucle;
					
					touchesModifies = false;
					toucheDejaPrise = false;						
	
					SonManager.getSonManager().jouerBeep();						
				}
				else if (clavier.isEntrer() && choix < 7) 
				{
					clavier.entrerOk();
					waitKey = true;
					toucheDejaPrise = false;						
					SonManager.getSonManager().jouerBeep();						
				}
				else if (clavier.isEntrer() && choix == 7) 
				{
					clavier.entrerOk();
					writeOptions();
					clavier.loadKeys();
					touchesModifies = true;
					toucheDejaPrise = false;						
					SonManager.getSonManager().jouerBeep();							
				}					
			}
			else
			{
				
				// MAPPAGE DE KEY
				if( clavier.getDerniereToucheAppuye() != 27 && clavier.getDerniereToucheAppuye() != 10)
				{
					boolean ok = true;				
					
					// VERIF QUE LA TOUCHE N4EST PAS DEJA PRISE
					for( int i=0; i<numTouches.length; i++)
						if( clavier.getDerniereToucheAppuye() == numTouches[i] && choix != i)
							ok = false;
					
					//SI OK
					if( ok )
						numTouches[choix] = clavier.getDerniereToucheAppuye();
					else
						toucheDejaPrise = true;
					
					waitKey = false;
					clavier.allOk();
				}
			}
			
			
		}
	}		
	
	/**
	 * shape
	 */
	public void shape(Graphics2D graphics2D) 
	{
		graphics2D.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_OFF);
		graphics2D.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
		graphics2D.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_SPEED);
		graphics2D.setRenderingHint(RenderingHints.KEY_COLOR_RENDERING, RenderingHints.VALUE_COLOR_RENDER_SPEED);
		graphics2D.setRenderingHint(RenderingHints.KEY_FRACTIONALMETRICS, RenderingHints.VALUE_FRACTIONALMETRICS_OFF);
		graphics2D.setRenderingHint(RenderingHints.KEY_DITHERING, RenderingHints.VALUE_DITHER_DISABLE);	
		
		graphics2D.fillRect(0, 0, 800, 600);
		graphics2D.drawImage( fond.getImage(),0,0, null );
		
		// POLICE
		graphics2D.setFont(new Font(Font.MONOSPACED, Font.BOLD, 13));		
		
		// MENU
		for( int i=0; i< touches.length; i++)
		{
			if( i == choix )
				graphics2D.setColor( Color.blue );
			else
				graphics2D.setColor( Color.black );
				
			if( i < 7 )
				graphics2D.drawString( ":     "+KeyEvent.getKeyText( numTouches[i] ), 830, 175 + i*20);

			graphics2D.drawString( touches[i], 770, 175 + i*20);				
		}
		
		//PRESSEZ UNE TOUCHE
		if( waitKey )
		{
			graphics2D.setColor( Color.black );		
			graphics2D.setFont(new Font(Font.MONOSPACED, Font.BOLD, 30));	
			graphics2D.drawString( "PRESS A NON ASSIGNED KEY", 330, 585);			
		}
		
		// OK
		if( touchesModifies )
		{
			graphics2D.setColor( Color.black );		
			graphics2D.setFont(new Font(Font.MONOSPACED, Font.BOLD, 30));	
			graphics2D.drawString( "KEYS SUCCEFULLY SAVED", 330, 585);				
		}
		
		// ERREUR
		if( toucheDejaPrise )
		{
			graphics2D.setColor( Color.black );		
			graphics2D.setFont(new Font(Font.MONOSPACED, Font.BOLD, 30));	
			graphics2D.drawString( "ERROR KEY ALREADY ASSIGNED", 320, 585);				
		}		
		
	}	

	public boolean getGoMenuOption()
	{
		if( clavier.isEntrer() && choix == 8 || clavier.isESC()  )
		{
			choix = 0;
			clavier.allOk();
			return true;
		}
		
		return false;
	}	
	
	
	public String getTypeDeMenu()
	{
		return "MenuClavier";
	}
	
}

