package menus;

import java.awt.Graphics2D;
import java.awt.Toolkit;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Properties;
import javax.swing.ImageIcon;
import controles.SonManager;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class MenuOptions extends Menu
{
	
	private static final long serialVersionUID = 1L;

	private ImageIcon [] coins;
	private ImageIcon [] on;
	private ImageIcon [] diff;
	
	private int nombreDeContinus;
    private int isFullScreen;
    private int isAntiAliasing;
    private int isEffects;
    private int difficulte;

    /**
     * Constructeur
     */
	public MenuOptions()
	{
		String path = this.getClass().getResource(".").getPath().replaceAll("%20", " ");
		path 		+= "../../";		
		menu 		= new ImageIcon [7];
		menuChoix 	= new ImageIcon [7];
		coins 		= new ImageIcon [4];
		on 			= new ImageIcon [2];
		diff 		= new ImageIcon [2];

		menu[0] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/continues.png"));
		menu[1] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/difficulty.png"));		
		menu[2] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/fullscreen.png"));
		menu[3] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/antialiasing.png"));
		menu[4] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/effects.png"));		
		menu[5] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/keyboard.png"));
		menu[6] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/retour.png"));

		menuChoix[0] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/continues_bleu.png"));
		menuChoix[1] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/difficulty_bleu.png"));				
		menuChoix[2] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/fullscreen_bleu.png"));
		menuChoix[3] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/antialiasing_bleu.png"));	
		menuChoix[4] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/effects_bleu.png"));		
		menuChoix[5] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/keyboard_bleu.png"));
		menuChoix[6] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/retour_bleu.png"));
		
		coins[0] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/1.png"));
		coins[1] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/3.png"));
		coins[2] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/5.png"));
		coins[3] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/9.png"));	
		
		on[0] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/on.png"));
		on[1] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/off.png"));
		
		diff[0] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/normal.png"));
		diff[1] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/hard.png"));		

		fond = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/options.png"));		

		typeDeMenu = "MenuOptions";	
		
		// CONTINUS
		readOptions();
		
		if( ! ( nombreDeContinus ==1 || nombreDeContinus == 3 || nombreDeContinus == 5 || nombreDeContinus == 9) )
			nombreDeContinus = 3;
		
		ecart = 30;
		
	}

	
	/**
	 * Lit le fichier options.dat
	 */
	public void readOptions()
	{
		Properties lecteur = new Properties();

		FileInputStream fichier;
		
		try
		{
			fichier = new FileInputStream("Data/options.dat");
			lecteur.load(fichier);
			fichier.close();
			nombreDeContinus 	= Integer.parseInt( lecteur.getProperty( "nombreDeContinus"	) );	
			isFullScreen 		= Integer.parseInt( lecteur.getProperty( "fullScreen"		) );
			isAntiAliasing		= Integer.parseInt( lecteur.getProperty( "antiAliasing"		) );
			isEffects			= Integer.parseInt( lecteur.getProperty( "effects"			) );			
			isEffects			= Integer.parseInt( lecteur.getProperty( "effects"			) );
			difficulte			= Integer.parseInt( lecteur.getProperty( "difficulte"		) );
		}
		catch( Exception e)
		{
			nombreDeContinus = 3;
		}
	}
	
	
	/**
	 * Ecrit dans le fichier options.dat
	 */
	public void writeOptions()
	{
		Properties lecteur = new Properties();
		FileInputStream fichier;
		FileOutputStream fichier2;
		try
		{
			fichier = new FileInputStream("Data/options.dat");
			lecteur.load(fichier);
			fichier.close();
			
			lecteur.setProperty("nombreDeContinus"	,Integer.toString( nombreDeContinus ) );	
			lecteur.setProperty("fullScreen"		,Integer.toString( isFullScreen 	) );	
			lecteur.setProperty("antiAliasing"		,Integer.toString( isAntiAliasing 	) );	
			lecteur.setProperty("effects"			,Integer.toString( isEffects 		) );	
			lecteur.setProperty("difficulte"		,Integer.toString( difficulte 		) );	
					
			fichier2 = new FileOutputStream("Data/options.dat");
			lecteur.store( fichier2 , null);
			fichier2.close();
			
		}
		catch( Exception e){}
	}	
	
	/**
	 * Refresh
	 */
	public void refresh(long t) 
	{
		super.refresh(t);
		
		// APPUI OK SUR COINS
		if( clavier.isEntrer() && choix == 0)
		{
			if( nombreDeContinus == 5 )
				nombreDeContinus+=2;
			nombreDeContinus+=2;
				
			if( nombreDeContinus > 9 )
				nombreDeContinus = 1;
			
			clavier.entrerOk();
			SonManager.getSonManager().jouerBeep();					
		}
		
		// APPUI OK SUR FULL SCREEN
		if( clavier.isEntrer() && choix == 1)
		{
			difficulte = 1 - difficulte;
			clavier.entrerOk();
			SonManager.getSonManager().jouerBeep();					
		}	

		// APPUI OK SUR FULL SCREEN
		if( clavier.isEntrer() && choix == 2)
		{
			isFullScreen = 1 - isFullScreen;
			clavier.entrerOk();
			SonManager.getSonManager().jouerBeep();					
		}	
		
		// APPUI OK SUR ANTIALISASING
		if( clavier.isEntrer() && choix == 3)
		{
			isAntiAliasing = 1 - isAntiAliasing;
			clavier.entrerOk();
			SonManager.getSonManager().jouerBeep();					
		}	
		
		// APPUI OK SUR ANTIALISASING
		if( clavier.isEntrer() && choix == 4)
		{
			isEffects = 1 - isEffects;
			clavier.entrerOk();
			SonManager.getSonManager().jouerBeep();						
		}			
		
		boucle = System.currentTimeMillis();
		
		// affichage dans la fen�tre		

		// d�placement dans le menu
		if ( boucle - dernierDeplacement > 200 ) 
		{
			// Si haut
			if (clavier.isGauche()) 
			{
				//APPUI GAUCHE SUR COINS
				if( choix == 0 )
				{
					if( nombreDeContinus == 9 )
						nombreDeContinus-=2;
					nombreDeContinus-=2;
						
					if( nombreDeContinus < 1 )
						nombreDeContinus = 9;
				
					dernierDeplacement = boucle;
					SonManager.getSonManager().jouerBeep();		
				}
				else if( choix == 1 )
				{
					difficulte = 1 - difficulte;
					clavier.entrerOk();
					dernierDeplacement = boucle;
					SonManager.getSonManager().jouerBeep();								
				}				
				//APPUI GAUCHE SUR PLEIN ECRAN
				else if( choix == 2 )
				{
					isFullScreen = 1 - isFullScreen;
					clavier.entrerOk();
					dernierDeplacement = boucle;
					SonManager.getSonManager().jouerBeep();							
				}
				else if( choix == 3 )
				{
					isAntiAliasing = 1 - isAntiAliasing;
					clavier.entrerOk();
					dernierDeplacement = boucle;
					SonManager.getSonManager().jouerBeep();								
				}
				else if( choix == 4 )
				{
					isEffects = 1 - isEffects;
					clavier.entrerOk();
					dernierDeplacement = boucle;
					SonManager.getSonManager().jouerBeep();								
				}				

			}
			// Si droite
			else if (clavier.isDroite()) 
			{
				if( choix == 0 )
				{					
					if( nombreDeContinus == 5 )
						nombreDeContinus+=2;
					nombreDeContinus+=2;
						
					if( nombreDeContinus > 9 )
						nombreDeContinus = 1;
					
					dernierDeplacement = boucle;
					SonManager.getSonManager().jouerBeep();		
				}
				else if( choix == 1 )
				{
					difficulte = 1 - difficulte;
					clavier.entrerOk();
					dernierDeplacement = boucle;
					SonManager.getSonManager().jouerBeep();							
				}
				else if( choix == 2 )
				{
					isFullScreen = 1 - isFullScreen;
					clavier.entrerOk();
					dernierDeplacement = boucle;
					SonManager.getSonManager().jouerBeep();							
				}
				else if( choix == 3 )
				{
					isAntiAliasing = 1 - isAntiAliasing;
					clavier.entrerOk();
					dernierDeplacement = boucle;
					SonManager.getSonManager().jouerBeep();		;						
				}
				else if( choix == 4 )
				{
					isEffects = 1 - isEffects;
					clavier.entrerOk();
					dernierDeplacement = boucle;
					SonManager.getSonManager().jouerBeep();		;						
				}					
			}	
		}
	}
	
	public void shape(Graphics2D graphics2D) 
	{
		super.shape(graphics2D);
		
		if( nombreDeContinus == 1 )
			graphics2D.drawImage(coins[0].getImage(), 780, 165, null);
		else if( nombreDeContinus == 3 )
			graphics2D.drawImage(coins[1].getImage(), 780, 165, null);			
		else if( nombreDeContinus == 5 )
			graphics2D.drawImage(coins[2].getImage(), 780, 165, null);			
		else if( nombreDeContinus == 9 )
			graphics2D.drawImage(coins[3].getImage(), 780, 165, null);
	
		if( difficulte == 0 )
			graphics2D.drawImage(diff[0].getImage(), 780, 165 + 30, null);
		else
			graphics2D.drawImage(diff[1].getImage(), 780, 165 + 30, null);		
		
		if( isFullScreen == 0 )
			graphics2D.drawImage(on[1].getImage(), 780, 165 + 60, null);
		else
			graphics2D.drawImage(on[0].getImage(), 780, 165 + 60, null);			

	
		if( isAntiAliasing == 0 )
			graphics2D.drawImage(on[1].getImage(), 780, 165 + 90, null);
		else
			graphics2D.drawImage(on[0].getImage(), 780, 165 + 90, null);			

			
		if( isEffects == 0 )
			graphics2D.drawImage(on[1].getImage(), 780, 165 + 120, null);
		else
			graphics2D.drawImage(on[0].getImage(), 780, 165 + 120, null);			
		

				
	}
	
	public boolean getGoMenuClavier()
	{
		return clavier.isEntrer() && choix == 5;
	}	
	
	public boolean getGoMenuPrincipal()
	{
		// SI on a effectivement appuy�
		if( clavier.isEntrer() && choix == 6 || clavier.isESC() )
		{
			writeOptions();
			choix = 0;
			return true;
		}

		return false;
	}

}
