package menus;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.Toolkit;
import java.io.FileInputStream;
import java.util.Properties;
import javax.swing.ImageIcon;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class MenuScore extends Menu
{
	private static final long serialVersionUID = 1L;
	private String[] score;
	private String[] nomsScore;

	public MenuScore()
	{
		menu = null;
		menuChoix = new ImageIcon[1];
		menuChoix[0] = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/Choix/retour_bleu.png"));
		
		score		= new String[10];
		nomsScore	= new String[10];
		readScore();
		
		typeDeMenu = "MenuScore";
		fond = new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Menus/scores.png"));
	}
	
	public void readScore()
	{
		
		Properties lecteur = new Properties();

		FileInputStream fichier;
		
		try
		{
			fichier = new FileInputStream("Data/scores.dat");
			lecteur.load(fichier);
			fichier.close();
			
			for( int i=0;i<score.length;i++)
				score[i] =  lecteur.getProperty("score"+(i+1));
			
			for( int i=0;i<score.length;i++)
				nomsScore[i] =  lecteur.getProperty("init"+(i+1));

		}
		catch( Exception e)
		{
			for( int i=0;i<score.length;i++)
				score[i] = "AAA          0000000000";
		}
	}	
	
	public void refresh(long t) 
	{
	}
	
	public void shape(Graphics2D graphics2D) 
	{
		graphics2D.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		graphics2D.setColor(Color.white);
		graphics2D.fillRect(0, 0, 800, 600);
		
		// FOND
		graphics2D.drawImage( fond.getImage(),0,0, null );
		
		// RETOUR
		graphics2D.drawImage( menuChoix[0].getImage(), 760, 635, null );
		
		// POSITION
		graphics2D.setFont(new Font(Font.MONOSPACED, Font.BOLD, 20));		
		graphics2D.setColor(Color.darkGray);	
		for(int i=0;i<score.length;i++)
			graphics2D.drawString((i+1)+".", 590, 185+i*35);

		// SCORES
		graphics2D.setFont(new Font(Font.SANS_SERIF, Font.BOLD, 24));		
		graphics2D.setColor(Color.BLACK);			
		for(int i=0;i<score.length;i++)
			graphics2D.drawString( nomsScore[i], 630, 185+i*35 );
		
		for(int i=0;i<score.length;i++)
			graphics2D.drawString( score[i], 790, 185+i*35 );
	}	
	
	public boolean getGoMenuPrincipal()
	{
		return clavier.isEntrer() && choix == 0 || clavier.isESC();
	}
}
