package niveaux;

import java.awt.Graphics;
import javax.swing.ImageIcon;
import controles.Environnement;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class Niveau 
{
	protected int niveau;
	
	protected float yBackground;
	protected float yForeground;	
	protected float speedBackground;
	protected float speedForeground;
	
	
	protected ImageIcon background;
	protected ImageIcon foreground;
		
	
	public Niveau( int sb, int sf)
	{
		speedBackground = sb;
		speedForeground = sf;
	}
	
	
	public void setScrolling( int vitesse )
	{
		speedBackground = vitesse;
		speedForeground = (int)(vitesse*1.5);
	}
	
	public int getScrolling()
	{
		return (int)speedBackground;
	}
	
	
	/**
	 * Refresh Global
	 * @param t
	 */
	public void refresh(long t) 
	{
		if( ! Environnement.getEnvironnement().isPause() )
		{
			// Carte
			yBackground += (speedBackground*t)/1000.0;
			
			if( yBackground > 0 )
				yBackground = - background.getIconHeight() + 768;
			
			//Clouds
			yForeground += (speedForeground*t)/1000.0;
			
			if( yForeground > 0 )
				yForeground = - foreground.getIconHeight() + 768;		
			
		}
	}			
	
	
	/**
	 * Shape global background
	 * @param graphics
	 */
	public void shapeBackground(Graphics graphics) 
	{
		graphics.drawImage( background.getImage() ,212, (int)yBackground, null );
	}
	
	
	/**
	 * Shape global foreground
	 * @param graphics
	 */
	public void shapeForeground(Graphics graphics) 
	{
		if( Environnement.getEnvironnement().effects == 1 )
			graphics.drawImage( foreground.getImage() ,212, (int)yForeground, null  );
	}	
	
}
