package niveaux;

import java.awt.Graphics;
import java.awt.Toolkit;
import java.util.Random;
import javax.swing.ImageIcon;
import controles.Environnement;
import controles.ImageManager;

/**
 * 
 * @author Jerome Baudoux : http://www.jerome-baudoux.com
 *
 */
public class Niveau2 extends Niveau
{
	Random rand;
	
	float yMoon;
	float xMoon;
	float sMoon;

	protected ImageIcon moon1;	
	protected ImageIcon moon2;	
	protected ImageIcon moonCurr;
	
	public Niveau2()
	{
		super(60,200);
		
		background 	= new ImageIcon( Toolkit.getDefaultToolkit().getImage("Images/Maps/map2.png"		));
		foreground 	= background;
		
		if( Environnement.getEnvironnement().effects == 1 )
		{
			moon1 		= new ImageIcon( Toolkit.getDefaultToolkit().getImage("Images/Maps/map2_moon1.png"	));
			moon2 		= new ImageIcon( Toolkit.getDefaultToolkit().getImage("Images/Maps/map2_moon2.png"	));
		}
		
		moonCurr	= moon1;
		yMoon 		= -800;
		xMoon		=  212;
		sMoon		=  100;
		
		rand = new Random();
		
		ImageManager.getImagemanager().boss 	= new ImageIcon[11];
		ImageManager.getImagemanager().boss[0] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Boss/b2.png"));
		ImageManager.getImagemanager().boss[1] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Boss/b2_1.png"));
		ImageManager.getImagemanager().boss[2] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Boss/b2_2.png"));
		ImageManager.getImagemanager().boss[3] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Boss/b2_3.png"));
		ImageManager.getImagemanager().boss[4] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Boss/b2_4.png"));
		ImageManager.getImagemanager().boss[5] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Boss/b2_1_1.png"));
		ImageManager.getImagemanager().boss[6] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Boss/b2_2_1.png"));
		ImageManager.getImagemanager().boss[7] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Boss/b2_3_1.png"));
		ImageManager.getImagemanager().boss[8] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Boss/b2_4_1.png"));
		ImageManager.getImagemanager().boss[9] 	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Boss/b2Sub.png"));
		ImageManager.getImagemanager().boss[10]	= new ImageIcon(Toolkit.getDefaultToolkit().getImage("Images/Boss/b2Sub2.png"));
		
		Environnement.getEnvironnement().joueur.setLight(true);
	}
	
	/**
	 * Refresh Global
	 * @param t
	 */
	public void refresh(long t) 
	{
		super.refresh(t);
		
		if( ! Environnement.getEnvironnement().isPause() && Environnement.getEnvironnement().effects == 1 )
		{
			// Lune
			yMoon += ( ((sMoon-15)+speedBackground) *t)/1000.0;
			
			// Si mode boss, on ne la remet pas a jour
			if( yMoon > 6000  && ! Environnement.getEnvironnement().modeBoss )
			{
				if( moonCurr == moon1 )
					moonCurr = moon2;
				else
					moonCurr = moon1;
				
				yMoon = -800;
				xMoon = rand.nextFloat()*1024-300;
				sMoon =(rand.nextFloat()*30) + 70;
			}
		}
	}			
	
	
	/**
	 * Shape global background
	 * @param graphics
	 */
	public void shapeBackground(Graphics graphics) 
	{
		super.shapeBackground(graphics);
		
		if( yMoon < 768 && Environnement.getEnvironnement().effects == 1 )
			graphics.drawImage( moonCurr.getImage() , (int)xMoon, (int)yMoon, (int)(moon1.getIconWidth()*sMoon/100), (int)(moon1.getIconHeight()*sMoon/100), null);

	}	
	
	
	/**
	 * Shape global foreground
	 * @param graphics
	 */
	public void shapeForeground(Graphics graphics) 
	{

	}		
}
